//-----------------------------------------------------------------------------
//
//  $Logfile:: /2015/box.h                                                    $
// $Revision:: 1                                                              $
//   $Author:: Burgermac                                                      $
//     $Date:: 12/27/00 5:20 PM                                               $
//
// Copyright (C) 1997 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// DESCRIPTION:
// Explodable box that falls when boxes below it are destroyed.
// 

#ifndef __BOX_H__
#define __BOX_H__

#include "g_local.h"
#include "entity.h"
#include "archive.h"

//###
extern Event EV_Box_StartThread;
extern Event EV_Box_SetThread;
//###

class EXPORT_FROM_DLL Box : public Entity
	{
	private:
		float 			movetime;
      Burger::String            items;
      qboolean       setangles;
	  Burger::String			thread; //###
   
	public:
      CLASS_PROTOTYPE( Box );

							Box();
		void				StartFalling( void );
		void				Falling( Event *ev );
		void				TellNeighborsToFall( void );
		virtual void	Killed( Event *ev );
		//###
		void        StartThread(Event *ev);
		void        EventSetThread(Event *ev);
		//###
	   virtual void   Archive( Archiver &arc );
      virtual void   Unarchive( Archiver &arc );
	};

inline EXPORT_FROM_DLL void Box::Archive
	(
	Archiver &arc
	)
   {
   Entity::Archive( arc );

   arc.WriteFloat( movetime );
   arc.WriteCString( items.c_str());
   arc.WriteBoolean( setangles );
   arc.WriteCString(thread.c_str()); //###
   }

inline EXPORT_FROM_DLL void Box::Unarchive
	(
	Archiver &arc
	)
   {
   Entity::Unarchive( arc );

   movetime = arc.ReadFloat();
   arc.ReadString( &items );
   setangles = arc.ReadBoolean();
   arc.ReadString( &thread ); //###
   }

#endif /* box.h */
