//-----------------------------------------------------------------------------
//
//  $Logfile:: /2015/bullet.h                                                 $
// $Revision:: 1                                                              $
//   $Author:: Burgermac                                                      $
//     $Date:: 12/27/00 5:20 PM                                               $
//
// Copyright (C) 1997 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// DESCRIPTION:
// Base class for all bullet (hitscan) weapons.  Includes definition for shotgun.
// 

#ifndef __BULLET_H__
#define __BULLET_H__

#include "g_local.h"
#include "item.h"
#include "weapon.h"

#define MAX_RICOCHETS 10

class EXPORT_FROM_DLL BulletWeapon : public Weapon
{
protected:
	qboolean damagedtarget; //###

	virtual void	TraceAttack(const Vector &start,const Vector &end, int damage, trace_t *trace, int numricochets, int kick, int dflags, int meansofdeath, qboolean server_effects );
	virtual void   FireTracer( void );

public:
	CLASS_PROTOTYPE( BulletWeapon );

	BulletWeapon();
	virtual void FireBullets( int numbullets,const Vector &spread, int mindamage, int maxdamage, int dflags, int meansofdeath, qboolean server_effects );

	//###
	virtual void Archive(Archiver &arc);
	virtual void Unarchive(Archiver &arc);
	//###
};

//###
inline EXPORT_FROM_DLL void BulletWeapon::Archive (Archiver &arc)
{
	Weapon::Archive( arc );

	arc.WriteBoolean(damagedtarget);
}

inline EXPORT_FROM_DLL void BulletWeapon::Unarchive (Archiver &arc)
{
	Weapon::Unarchive( arc );

	damagedtarget = arc.ReadBoolean();
}
//###

#endif /* BULLET.h */
