#include <burger.h>
#include "Mac_Drawsp.h"
#include "mac_import.h"


/**********************************

	Perform a software screen update

**********************************/


#if 0
/***********************************************************************\
    *                                                                     
  *
    * name:     BlitLargeAlign                                            
  *
    *                                                                     
  *
    * descr:    Pixel-doubling code - needs 16-byte aligned buffers,      
  *
    *           pixel-double from draw_buffer to dstPtr.                  
  *
    *                                                                     
  *
    
\***********************************************************************/



        #define fpTemp      fp0
        #define rSrcPtr     r3
        #define rDblDStrd   r4
        #define rDst1Ptr    r5
        #define rWidth      r6
        #define rHeight     r7
        #define rModulus    r8
        #define rSStrd      r9
//      #define rLDblPtr    r30
//      #define rDst2Ptr    r31


static asm void BlitLargeAlign
    (
        char * draw_buffer,
        long dstRowBytes,
        char * dstPtr,
        long width,
        long height,
        long srcRowBytes
    )
{
    register char *rLDblPtr;
    register char *rDst2Ptr;
    char localbuf[ 8 ];
    
        fralloc
        
    //  Save non-volatile registers in red zone
    
//      stw     r31,-4(SP)              // store non-volatile reg in red zone
        addi    rDst1Ptr,rDst1Ptr,-8    // subtract 8 from dst
//      stw     r30,-8(SP)              // store non-volatile reg in red zone

//      la      rLDblPtr,-16(SP)        // calculate copy of local 8-byte variable
        la      rLDblPtr, localbuf
        sub     rSStrd,rModulus,rWidth  // rSStrd = modulus - w
        add     rDst2Ptr,rDst1Ptr,r4    // dst2 = dstRowBytes + dst1
        sub     r4,r4,rWidth            // r4 = dstRowBytes - w
        addi    rHeight,rHeight,-1      // subtract 1 from height count
        srawi   rWidth,rWidth,2         // rWidth = w >> 2
        addi    rSrcPtr,rSrcPtr,-4      // subtract 4 from src
        addi    rWidth,rWidth,-1        // subtract 1 from width count
        add     rDblDStrd,r4,r4         // rDblDStrd = 2 * r4

    //  Copy rows from source to dest
    //  (y count is in rHeight)
    
BlitLargeAlignY:        
        lwzu    r10,4(rSrcPtr)                  // load a long into r10
        mr      r0,r10                          // put a copy in r0
        mr      r11,r10
        rlwimi  r0,r10,24,8,23                  // inslwi r0,r10,16,8
        rlwimi  r11,r10,8,8,23                  // insrwi r11,r10,16,8
        rlwimi  r0,r10,16,24,31
        stw     r0,0(rLDblPtr)
        rlwimi  r11,r10,16,0,7
        stw     r11,4(rLDblPtr)
        mtctr   rWidth                          // copy x count into the counter
        lfd     fpTemp,0(rLDblPtr)

BlitLargeAlignX:
        lwzu    r10,4(rSrcPtr)                  // load a long into r10
        stfdu   fpTemp,8(rDst1Ptr)
        mr      r0,r10                          // put a copy in r0
        mr      r11,r10
        rlwimi  r0,r10,24,8,23                  // inslwi r0,r10,16,8
        rlwimi  r11,r10,8,8,23                  // insrwi r11,r10,16,8
        rlwimi  r0,r10,16,24,31
        stw     r0,0(rLDblPtr)
        rlwimi  r11,r10,16,0,7
        stw     r11,4(rLDblPtr)
        stfdu   fpTemp,8(rDst2Ptr)
        lfd     fpTemp,0(rLDblPtr)
        bdnz    BlitLargeAlignX                 // loop over all x

        stfdu   fpTemp,8(rDst1Ptr)
        addic.  rHeight,rHeight,-1              // decrement the counter
        add     rSrcPtr,rSrcPtr,rSStrd          // src += sstride
        add     rDst1Ptr,rDst1Ptr,rDblDStrd     // dst1 += dstride
        stfdu   fpTemp,8(rDst2Ptr)
        add     rDst2Ptr,rDst2Ptr,rDblDStrd     // dst2 += dstride
        bne     BlitLargeAlignY                 // loop for all y

    //  Restore non-volatile registers before returning
    
//      lwz     r30,-8(SP)
//      lwz     r31,-4(SP)
    
        frfree
        blr                                     //  Return to caller
}
#endif
