/*

	This file is a bunch of misc. Mac subroutines that got thrown in here
	because they didn't quite fit anywhere else and I kept the common Quake
	headers incompatible with the Mac Universal Headers, so these couldn't
	be mixed in with the main Quake code
*/

#include "mac_isp.h"
#include "q_shared.h"
#include "modelessdlog.h"
#include "macfuncs.h"
#include "qcommon.h"
#include "q_shared.h"
#include <OpenTransport.h>
#include <AEInteraction.h>
#include <Scrap.h>
#include <MacWindows.h>
#include <ToolUtils.h>
#include <Dialogs.h>
#include <time.h>

// Menu bar crap
enum
{
	kMBAR_Main			=	128,

	kMENU_Apple			=	128,
	kMENU_File,
	kMENU_Edit
};

// directory searching
#define SFF_ARCH    0x01
#define SFF_HIDDEN  0x02
#define SFF_RDONLY  0x04
#define SFF_SUBDIR  0x08
#define SFF_SYSTEM  0x10

static Bool gConsoleSuspendFlag;

// --- Globals!
static OTTimeStamp gMasterTimeStamp;

static int DMenuBarDispatch(int inMenu, const short inModifiers)
{
SInt16		theMenu;
SInt16		theItem;
//UInt32		menuCommand;
MenuHandle	theMenuHandle;
Bool		handled = TRUE;
		
	theMenu = HiWord(inMenu);
	theItem = LoWord(inMenu);
	theMenuHandle = GetMenuHandle(theMenu);

	//	Small hackish thing because the menu command stuff doesn't
	//	bother mentioning that you got a desk accessory.
	if ((kMENU_Apple == theMenu) && (theItem > 2))
	{
	Str255	daName;
	GrafPtr	oldPort;
	
		GetPort(&oldPort);
		GetMenuItemText(theMenuHandle, theItem, daName);
//		OpenDeskAcc(daName);
		SetPort(oldPort);
	}
	else
	{
		if ( (theMenu == kMENU_Apple) && (theItem == 1) )
		{
			DoAboutDialog();
		}
	}

	HiliteMenu(0);
	DrawMenuBar();

	return (handled);
}

//	------------------------------	DefaultMouseDown

static Bool DefaultMouseDown(EventRecord *theEvent)
{
SInt16		whatPart;
SInt32		menuResult;
WindowRef	whichWindow;

//short whatItem;

	whatPart = FindWindow(theEvent->where, &whichWindow);

	switch (whatPart)
	{
		case inGoAway:
			//MDU_HandleClose(theEvent);
			break;

		case inMenuBar:
			DrawMenuBar();
			menuResult = MenuSelect(theEvent->where);

			if (HiWord(menuResult) != 0)
				DMenuBarDispatch(menuResult,theEvent->modifiers);
			break;

		case inSysWindow:
//			SystemClick(theEvent, whichWindow);
			break;
			
		case inContent:
			if (whichWindow != FrontWindow())
				SelectWindow(whichWindow);
			else
			{
				MDU_HandleClick(theEvent);			
			}
			break;
			
		case inDrag:
			if (whichWindow != FrontWindow())
			{
				SelectWindow(whichWindow);
			}
			MDU_HandleDrag(theEvent);
			break;
			
	}

	return (TRUE);
}

//	------------------------------	DefaultKeyDown

static Bool DefaultKeyDown(EventRecord *theEvent)
{
SInt8	theKey;
SInt8	theCode;
SInt32	menuResult;

//short whatItem;

	theKey = theEvent->message & charCodeMask;
	theCode = (theEvent->message & keyCodeMask) >> 8;
	if ((theEvent->modifiers & cmdKey) != 0)
	{
		menuResult = MenuKey(theKey);
		if (HiWord(menuResult) != 0)
			DMenuBarDispatch(menuResult,0);

		return (TRUE);
	}

	MDU_HandleKey(theEvent);
	return (TRUE);
}

static void EventDispatch(EventRecord *theEvent)
{
	switch (theEvent->what)
	{
		case nullEvent:	MDU_HandleIdle(theEvent);
						break;
		case mouseDown:	DefaultMouseDown(theEvent);
						break;
		case keyDown:	DefaultKeyDown(theEvent);
						break;
		case autoKey:	DefaultKeyDown(theEvent);
						break;
		case updateEvt:
//			BeginUpdate((WindowRef) theEvent->message);
//			DrawControls((WindowRef)theEvent->message);
			MDU_HandleUpdate(theEvent);
//			EndUpdate((WindowRef) theEvent->message);
			break;

		case diskEvt:
//			{
//			Point	thePoint;
//			SInt16	value;
//
//				if (theEvent->message & 0xFFFF0000)		//	Error mounting disk
//				{
//					SetPt(&thePoint, 100, 100);
//					value = DIBadMount(thePoint, theEvent->message);
//				}
//			}
			break;

		case osEvt:
			if (theEvent->message & 0x01000000)		//	Suspend/resume event
			{
				if (theEvent->message & 0x00000001)	//	Resume
				{
					gConsoleSuspendFlag = FALSE;
				}
				else
				{
					gConsoleSuspendFlag = TRUE;
				}
			}
			break;

		case kHighLevelEvent:
			AEProcessAppleEvent(theEvent);
			break;
	}
}





// ------------------------------------------------------------

char *_strdate2(char *str)
{
    time_t timer;
    
    time(&timer);
    strftime(str, 10, "%m/%d/%y", localtime(&timer));
    return str;
}


char *_strtime2(char *str)
{
    time_t timer;
    
    time(&timer);
    strftime(str, 10, "%I:%M:%S", localtime(&timer));
    return str;
}


/*

	This is a limited implementation of the 'findfirst' 'findnext' functionality.
	Only full path/filenames path/*.* or path/*.xxx are supported, we'll dump to
	a logfile in a debug lib to make sure we don't miss anything

uses from BurgerLib:
extern Word BURGERCALL OpenADirectory(DirectorySearch_t *Input,const char *Name);
extern Word BURGERCALL GetADirectoryEntry(DirectorySearch_t *Input);
extern Word BURGERCALL GetADirectoryEntryExtension(DirectorySearch_t *Input,const char *ExtPtr);
extern void BURGERCALL CloseADirectory(DirectorySearch_t *Input);
extern void * BURGERCALL ConvertNativePathToPath(const char *FileName);

*/

char findpath[MAX_OSPATH];
char findbase[MAX_OSPATH];
static int ffsearchtype;
static char *bfullpath;	// pointer to full path in BurgerLib format
static char *dfullpath;	// pointer to directory path in BurgerLib format
static Burger::DirectorySearch theDir;
static int dirOpened = FALSE;
static int offset;

const char *Sys_FindFirst (const char *path, unsigned musthave, unsigned canthave)
{
int isdone;
int directoryOnly;
char temppath[4096];
int strip0;
char *returnstring;	
	
	if ((musthave & SFF_SUBDIR) != 0)
		directoryOnly = TRUE;
	else
		directoryOnly = FALSE;

	temppath[0] = '9';	// do burgerlib app prefix
	temppath[1] = ':';
//NCT_MAC strip ./ off of paths
	if ( (path[0] == '.') && (path[1] == '/'))
	{
		Burger::StringCopy(&temppath[2],&path[2]);
		strip0 = 2;
		while (temppath[strip0] != 0)
		{
			if ( (temppath[strip0] == '/') || (temppath[strip0] == '\\') )
				temppath[strip0] = ':';
			else
				temppath[strip0] = temppath[strip0];
			++strip0;
		}
		temppath[strip0] = 0;
	}
	
	COM_FilePath(path,findbase);
	ffsearchtype = 0;		// full filename by default
	bfullpath = Burger::StringDuplicate(temppath);
	if (bfullpath == NULL)
	{
		Sys_Error("ConvertNativePathToPath Failed in Sys_FindFirst");
		return(bfullpath);
	}
	
	// figure out if I have a full filename, a *.* or a *.xxx
	offset = Burger::StringLength(bfullpath);
	--offset;	// past 0
	while (offset >= 0)
	{
		if (bfullpath[offset] == ':')
			break;
		--offset;
	}
	++offset;	//bump past :
	if (bfullpath[offset] == '*')
	{
		if (bfullpath[offset+1] == '.')
		{
			++ffsearchtype;
			if (bfullpath[offset+2] == '*')
				++ffsearchtype;
		}
	}
	// ffsearchtype = 0  - full path
	// ffsearchtype = 1  - *.xxx extension wildcard
	// ffsearchtype = 2  - *.* all files wildcard
	
	if (offset > 0)		//do we have a /x/x/blah path or just a filename?
	{
		//path
		dfullpath = Burger::StringDuplicate(bfullpath);
		dfullpath[offset-1] = 0;	//zero last : to isolate directory
	} else {
		//file
		dfullpath = Burger::StringDuplicate("9:");		//burgerlib application directory prefix
	}
	
	if (ffsearchtype == 0)	//only a specific file?
	{
		dirOpened = FALSE;
		if (Burger::FileManager::DoesFileExist(bfullpath) == FALSE)
			return(NULL);
		Burger::StringCopy(findpath,path);
	}
	else
	{
		isdone = TRUE;	// assume failure
		theDir.Open(dfullpath);
		dirOpened = TRUE;
		if (ffsearchtype == 1)
		{
			isdone = theDir.GetNextEntryExtension(&bfullpath[offset+2]);
		}
		else
		{
			// separate for scanning for subdirectories
			if (directoryOnly == FALSE)
			{
				isdone = theDir.GetNextEntry();
			}
			else
			{
				int hitEnd = FALSE;
				while (hitEnd == FALSE)
				{
					hitEnd = theDir.GetNextEntry();
					if (hitEnd == FALSE)
					{
						if (theDir.m_bDir == TRUE)
							break;
					}
				}
				isdone = hitEnd;
			}
		}
		if (isdone == TRUE)
			return(NULL);
		Com_sprintf(findpath,sizeof(findpath),"%s/%s",findbase,theDir.m_Name);
	}
		
	returnstring = Burger::StringDuplicate(findpath);
	return(returnstring);
}

const char *Sys_FindNext (unsigned musthave, unsigned canthave)
{
int isdone;
int directoryOnly;
char *returnstring;	

	if ((musthave & SFF_SUBDIR) != 0)
		directoryOnly = TRUE;
	else
		directoryOnly = FALSE;

	if (ffsearchtype == 0)	//only a specific file?
	{
		return(NULL);
	}
	else
	{
		isdone = TRUE;	// assume failure
		if (ffsearchtype == 1)
		{
			isdone = theDir.GetNextEntryExtension(&bfullpath[offset+2]);
		}
		else
		{
			// separate for scanning for subdirectories
			if (directoryOnly == FALSE)
			{
				isdone = theDir.GetNextEntry();
			}
			else
			{
				int hitEnd = FALSE;
				while (hitEnd == FALSE)
				{
					hitEnd = theDir.GetNextEntry();
					if (hitEnd == FALSE)
					{
						if (theDir.m_bDir == TRUE)
							break;
					}
				}
				isdone = hitEnd;
			}
		}
		if (isdone == TRUE)
			return(NULL);
		Com_sprintf(findpath,sizeof(findpath),"%s/%s",findbase,theDir.m_Name);
	}
		
	returnstring = Burger::StringDuplicate(findpath);
	return(returnstring);
}

void Sys_FindClose (void)
{
	if (dirOpened == TRUE) {	
		theDir.Close();
		dirOpened = FALSE;
	}
	Free(dfullpath);
	Free(bfullpath);
	dfullpath = 0;
	bfullpath = 0;
}


//=============================================================================
void InitTheBurger(void)
{
	KeyboardInit();			/* Enable the key board scanning code */
	MouseInit();			/* Use Burgerlib for mouse support */
}



// ------------------------------------------------------------
void	Sys_Init (void)
{
	// get the master base Open Transport timestamp for Sys_Milliseconds
	Sys_InitConsole();
	OTGetTimeStamp(&gMasterTimeStamp);

}




// ------------------------------------------------------------
void Mac_KillEvents(void)
{
	FlushEvents(everyEvent, 0);
	ShowCursor();
	InitCursor();
}




void Mac_WNE(Bool isStartup)
{
int tickEnter,tickCurr;
EventRecord theEvent;
short theMask;
unsigned long theSleep;

	tickEnter = TickCount();
	if (isStartup == TRUE)
	{
		tickEnter += 150;		// hang around for at least 2.5 secs looking for high level events	
		theMask = updateMask | diskMask | activMask | highLevelEventMask | osMask;
		theSleep = 20;
	}
	else
	{
		theMask = updateMask | diskMask | activMask | highLevelEventMask | osMask;
		theSleep = 3;
	}
	
	do
	{
		WaitNextEvent(theMask, &theEvent, theSleep, NULL);		
				
		switch (theEvent.what) {
			case kHighLevelEvent:
				AEProcessAppleEvent(&theEvent);
				break;
		}

		if ( (theEvent.modifiers & optionKey) != 0)
		{
			DoCommandLineDialog();
			tickCurr = tickEnter;
		}
		else
		{
			tickCurr = TickCount();
		}
	} while (tickCurr <= tickEnter);
}

// When Quake loads a file, it usually parses through the allocated file buffer
// and makes more allocations before freeing the file buffer.  Bad from a 
// fragmentation standpoint.  We'll allocate the file buffer as a handle,
// relocate it to the top of the heap and pass the pointer back to Quake

void MDebugXString(char *bah)
{
	return;
}

char *Mac_GetTextScrap(void)
{
	static char scrapcopy[256];
	Size leng;
#if !TARGET_API_MAC_CARBON
	char **tempTextH;
	long offset;
	tempTextH = NewHandle(256);
	HLock(tempTextH);
	leng = GetScrap(tempTextH,'TEXT',&offset);
	if (leng<=0) {
		return 0;
	}
	if (leng > 255) {
		leng = 255;	/* trim length down */
	}
	FastMemCpy(scrapcopy,tempTextH[0], leng);
	scrapcopy[leng] = 0; /* terminate string */
	DisposeHandle(tempTextH);
#else
	void *temp;
	ScrapRef MyScrap;
	if (GetCurrentScrap(&MyScrap)) {
		return 0;
	}
	if (GetScrapFlavorSize(MyScrap,'TEXT',&leng)) {
		return 0;
	}
	if (!leng) {
		return 0;
	}
	
	temp = Alloc(leng);
	GetScrapFlavorData(MyScrap,'TEXT',&leng,temp);
	if (leng > 255) {
		leng = 255;	/* trim length down */
	}
	FastMemCpy(scrapcopy,temp, leng);
	scrapcopy[leng] = 0; /* terminate string */
	Free(temp);
#endif
	return(scrapcopy);
}

char Mac_ConsoleInput(void)
{
static EventRecord event;
	MDebugXString("ConsoleInput!!!!\n");

#if !TARGET_API_MAC_CARBON
	if (!GetOSEvent(everyEvent,&event))
#else
	if (!GetNextEvent(everyEvent,&event))
#endif
	{
		MDU_HandleIdle(&event);
		return(0);
	}

	if (gConsoleSuspendFlag)
	{
		if ( ( (event.message & 0x01000000) != 0) && ((event.message & 0x00000001) != 0) )
			gConsoleSuspendFlag = FALSE;
		return(0);
	}			
	/* Do our own event thang */

		EventDispatch(&event);	

//	lastTime = TickCount();
//	nextTime = lastTime + 2;
		
	return(0);

}


// INPUT LINE CRAP FOR DEDICATED CONSOLE
DialogPtr gMainDialogPtr;
MDTemplate mainDialogTemp;
MDCtlTemplate mainCtlTemps[1];
int gMainDLOGReference;
int isInit = 0;

void Mac_InitInputLine(void)
{
//Handle itemHandle;
//Rect itemRect;
//short itemType;

	if (isInit)
		return;
	isInit = 1;

	MDU_Init();
	
	if (gMainDialogPtr == NULL)
	{
		gMainDialogPtr = GetNewDialog(4400,0,(WindowRef)-1);
		if (gMainDialogPtr == NULL)
			return;

		mainDialogTemp.theDialog = gMainDialogPtr;
		mainDialogTemp.theFlags = 0;
		mainDialogTemp.selectedEditText = 0xFFFFFFFF;
		mainDialogTemp.numItems = 1;
		mainDialogTemp.areEditText = TRUE;
		mainDialogTemp.firstCtl = mainCtlTemps;
		mainDialogTemp.closeCallback = NULL;
		mainDialogTemp.contentDraw = NULL;
		mainDialogTemp.controlCallback = NULL;

		MDU_SetCtlTemplate(&(mainCtlTemps[0]),
						   1, 
						   kEditTextDialogItem, 0, 0,
					   	   NULL,
					   	   NULL, NULL);


		gMainDLOGReference = MDU_RegisterDialog(&mainDialogTemp);
			
		MDU_ShowDialog(gMainDLOGReference);		
	}
	else
	{
		MDU_ShowDialog(gMainDLOGReference);
	}
	ShowDialogItem(gMainDialogPtr,1);
	DrawControls(GetDialogWindow(gMainDialogPtr));
}

