#if TARGET_API_MAC_CARBON
#define OTCARBONAPPLICATION 1
#endif

#include <burger.h>
#include <Files.h>
#include <OpenTransport.h>
#include <OpenTptInternet.h>
#include "macfuncs.h"

#define USEASYNC 1

// duplicating these since I'm not including the quake headers...
#ifdef __cplusplus
extern "C" {
#endif
extern void Com_Printf (char *fmt, ...);
extern void Sys_Error (const char *error, ...);
#ifdef __cplusplus
}
#endif

/*
typedef enum {NA_LOOPBACK, NA_BROADCAST, NA_IP, NA_IPX, NA_BROADCAST_IPX} netadrtype_t;

typedef enum {NS_CLIENT, NS_SERVER} netsrc_t;

typedef struct
{
	netadrtype_t	type;

	unsigned char	ip[4];
	unsigned char	ipx[10];

	unsigned short	port;
} netadr_t;
*/


// Prototypes

OSStatus DoStaticBind(EndpointRef ep, int index);
OSStatus DoGetInterfaceInfo(SInt32 i);
pascal void EventHandler(void*, OTEventCode event, OTResult, void*);
pascal void EventHandler2(void*, OTEventCode event, OTResult, void*);
void OT_KillUDP(int conref);
int OT_BroadcastUDP(int cref, unsigned char *ipref, unsigned short *portref, int length, void *data);
int OT_SendUDP(int cref, unsigned char *ipref, unsigned short *portref, int length, void *data);
int OT_GetUDP(int cref, void *data, int maxleng, unsigned char *theAddr, unsigned short *thePort);

#define MAX_OTCONS 2
#define ID_CONST	1000

// globals
int 				gOpenConnects = 0;
int 				gPortList[MAX_OTCONS];
InetAddress 		gConAddress[MAX_OTCONS];
InetAddress 		gRealConAddress[MAX_OTCONS];
EndpointRef			gEPref[MAX_OTCONS];
TEndpointInfo		gEPinfo[MAX_OTCONS];
OTNotifyUPP			gProcPtrs[MAX_OTCONS];
volatile UInt16		gBindCompleted;
volatile UInt16		gUnbindCompleted;
volatile UInt16		gDataToRead;
volatile UInt16		gDataToRead2;

InetHost			ourIPAddress;
InetHost			gBroadcastAddress;
InetAddress			sendAddress;
InetAddress			recvAddress;

static 				TUDErr uderr;

char otdbug[128];

#if 0
void OT_DumpInfo(void)
{
EndpointRef ep;
OTResult res;
int count;

	for (count = 0; count < 2; count++)
	{
		ep = gEPref[count];
		res = OTGetEndpointState(ep);
		switch(res) {
			case T_UNINIT:	Com_Printf("Endpoint %d state: T_UNINIT\n",count);
							break;
			case T_UNBND:	Com_Printf("Endpoint %d state: T_UNBND\n",count);
							break;
			case T_IDLE:	Com_Printf("Endpoint %d state: T_IDLE\n",count);
							break;
			case T_OUTCON:	Com_Printf("Endpoint %d state: T_OUTCON\n",count);
							break;
			case T_INCON:	Com_Printf("Endpoint %d state: T_INCON\n",count);
							break;
			case T_DATAXFER:	Com_Printf("Endpoint %d state: T_DATAXFER\n",count);
							break;
			case T_OUTREL:	Com_Printf("Endpoint %d state: T_OUTREL\n",count);
							break;
			case T_INREL:	Com_Printf("Endpoint %d state: T_INREL\n",count);
							break;
		}
		
		
	}
}
#endif

// ------------------------------------------------------
int OT_GetUDP(int cref, void *data, int maxleng, unsigned char *theAddr, unsigned short *thePort)
{
int dataWaiting;
EndpointRef ep;
	OSStatus	err = kOTNoError;
	TUnitData	unitdata;
	OTFlags		flags;
//	char		mystr[255];

	cref -= ID_CONST;

//Com_Printf("Hello\n");

	if (gOpenConnects < (cref+1))
	{
		MDebugXString("OT_GetUDP!  Endpoint not open error! \n");
	}

	ep = gEPref[cref];
#ifdef USEASYNC
/*
	if (cref == 0)
		dataWaiting = gDataToRead;
	else
		dataWaiting = gDataToRead2;
*/
	dataWaiting = TRUE;
#else
	dataWaiting = TRUE;
#endif
	
	if (dataWaiting == FALSE)
		return(-1);

//Com_Printf("Is Data waiting\n");

	// Receive a UDP datagram

	recvAddress.fAddressType = AF_INET;
	recvAddress.fPort = 0;
	recvAddress.fHost = 0;

	unitdata.addr.maxlen = sizeof(recvAddress);
	unitdata.addr.len = sizeof(recvAddress);
	unitdata.addr.buf = (UInt8*) &recvAddress;

	unitdata.opt.len = 0;
	unitdata.opt.maxlen = 0;
	unitdata.opt.buf = 0;
	
	unitdata.udata.len = maxleng;
	unitdata.udata.maxlen = maxleng;
	unitdata.udata.buf = (Word8*)data;

	flags = 0;

	err = OTRcvUData(ep, &unitdata, &flags);
	
	if ( (flags & T_MORE) != 0)
	{
		unsigned char *tempa;
		unsigned short tempp;
		int count,count2;
		MDebugXString("T_MORE GetUDP set! Fatal!\n");
		tempa = (unsigned char *) &recvAddress.fHost;
		tempp = (unsigned short) recvAddress.fPort;
		sprintf(otdbug,"Address %d.%d.%d.%d:%d \n",tempa[0],tempa[1],tempa[2],tempa[3],tempp);
		MDebugXString(otdbug);
		tempa = (unsigned char *) data;
		for (count2 = 0; count2 < 16; count2++)
		{
			for (count = 0; count < 16; count++)
			{
				sprintf(otdbug,"%02x ",*tempa++);
				MDebugXString(otdbug);
			}
			MDebugXString("\n");
		}
		Sys_Error("T_MORE in GetUDP set!  Overflow packet");
	}
	
	if ( err == kOTNoError )
	{
//		Com_Printf("Got data\n");
		*((InetHost *)theAddr) = recvAddress.fHost;
		*thePort = (unsigned short) recvAddress.fPort;
		return(unitdata.udata.len);
	}
	else
	{
		if (err == kOTNoDataErr)
		{
//			Com_Printf("No data\n");
			// reset our data waiting flag
			if (cref == 0)
				gDataToRead = 0;
			else
				gDataToRead2 = 0;
			return(-1);
		}
		else
		{
//			Com_Printf("OT_GetUDP error\n");
			sprintf(otdbug,"OT_GetUDP error: %d \n",err);
			MDebugXString(otdbug);
			if (err == kOTLookErr)
			{
				err = OTLook(ep);
				sprintf(otdbug,"OTLook error: %d \n",err);
				MDebugXString(otdbug);
				if (err == T_UDERR)
				{
					OTRcvUDErr(ep,&uderr);
					sprintf(otdbug,"OTRcvUDErr %d \n",uderr.error);
					MDebugXString(otdbug);
				}
			}
			return(-1);
		}
	}
}

// ------------------------------------------------------
int OT_BroadcastUDP(int cref, unsigned char *ipref, unsigned short *portref, int length, void *data)
{
InetPort thePort;
InetHost theHost;
TUnitData unitdata;
OSStatus err = kOTNoError;
EndpointRef ep;
unsigned char *addressmangle;

	cref -= ID_CONST;

	if (gOpenConnects < (cref+1))
	{
		MDebugXString("OT_BroadcastUDP!  Endpoint not open error! \n");
	}

	ep = gEPref[cref];
	thePort = (InetPort) *portref;
//	theHost = (InetHost) *((InetHost *)ipref);	// assuming byte order is okay here...kinda naughty
	theHost = ourIPAddress;

	addressmangle = (unsigned char *)(&theHost);
	
	// setup our broadcast address hack
	if (addressmangle[0] < 128)
	{
		//class A
		addressmangle[1] = 255;
		addressmangle[2] = 255;
		addressmangle[3] = 255;
	}
	else if (addressmangle[0] < 192)
	{
		//class B
		addressmangle[2] = 255;
		addressmangle[3] = 255;
	}
	else
	{
		//class C
		addressmangle[3] = 255;
	}

	OTInitInetAddress(&sendAddress,thePort,theHost);	//fix this to point to broadcast address

	unitdata.addr.len = sizeof(struct InetAddress);
	unitdata.addr.buf = (UInt8*) &sendAddress;
	unitdata.addr.maxlen = sizeof(struct InetAddress);

	unitdata.opt.len = 0;
	unitdata.opt.buf = 0;
	unitdata.opt.maxlen = 0;
	
	unitdata.udata.maxlen = length;
	unitdata.udata.len = length;
	unitdata.udata.buf = (UInt8*) data;

	if (ep != NULL)
		err = OTSndUData(ep, &unitdata);
	MDebugXString("SENT BROADCAST\n");
	if (err != kOTNoError)
	{
		Com_Printf("OT_BroadcastUDP ERR: SndUData\n");
		sprintf(otdbug,"OT_BroadcastUDP error: %d \n",err);
		MDebugXString(otdbug);
		if (err == kOTLookErr)
		{
			err = OTLook(ep);
			sprintf(otdbug,"OTLook error: %d \n",err);
			MDebugXString(otdbug);
			if (err == T_UDERR)
			{
				MDebugXString("OTRcvUDErr\n");
				OTRcvUDErr(ep,&uderr);
			}
		}
	}
	return 0;
}
// ------------------------------------------------------
int OT_SendUDP(int cref, unsigned char *ipref, unsigned short *portref, int length, void *data)
{
InetPort thePort;
InetHost theHost;
TUnitData unitdata;
OSStatus err = kOTNoError;
EndpointRef ep;

	cref -= ID_CONST;

	if (gOpenConnects < (cref+1))
	{
		MDebugXString("OT_SendUDP!  Endpoint not open error! \n");
	}

	ep = gEPref[cref];
	thePort = (InetPort) *portref;
	theHost = (InetHost) *((InetHost *)ipref);	// assuming byte order is okay here...kinda naughty

	OTInitInetAddress(&sendAddress,thePort,theHost);	//fix this to point to broadcast address

	unitdata.addr.len = sizeof(struct InetAddress);
	unitdata.addr.buf = (UInt8*) &sendAddress;
	unitdata.addr.maxlen = sizeof(struct InetAddress);

	unitdata.opt.len = 0;
	unitdata.opt.buf = 0;
	unitdata.opt.maxlen = 0;

	unitdata.udata.maxlen = length;
	unitdata.udata.len = length;
	unitdata.udata.buf = (UInt8*) data;

	if (ep != NULL)
		err = OTSndUData(ep, &unitdata);
	if (err != kOTNoError)
	{
//		Com_Printf("OT_SendUDP ERR: SndUData\n");
		sprintf(otdbug,"OT_SendUDP error: %d \n",err);
		MDebugXString(otdbug);
		if (err == kOTLookErr)
		{
			err = OTLook(ep);
			sprintf(otdbug,"OTLook error: %d \n",err);
			MDebugXString(otdbug);
			if (err == T_UDERR)
			{
				OTRcvUDErr(ep,&uderr);
				sprintf(otdbug,"OTRcvUDErr %d \n",uderr.error);
				MDebugXString(otdbug);
			}
		}
	}
	return 0;
}

// ------------------------------------------------------
int OT_InitUDP(const char *net_interface, int port)
{
	int index;
	OSStatus err = kOTNoError;
	EndpointRef ep;
	InetInterfaceInfo myInfo;

	MDebugXString("OT_InitUDP +++ \n");

	index = gOpenConnects;
	++gOpenConnects;
	if ((gOpenConnects) > MAX_OTCONS)
	{
		gOpenConnects = index;
		return(-1);
	}

	gPortList[index] = port;
	
	OTInitInetAddress(&gConAddress[index], port, (InetHost) 0);
	
	gEPref[index] = OTOpenEndpoint(OTCreateConfiguration(kUDPName), 0,&gEPinfo[index], &err);
	
	ep = gEPref[index];
	if (gEPref[index] == NULL || err != kOTNoError)
	{
		gEPref[index] = 0;
		Com_Printf("NET_OT ERR: Can't open Endpoint\n");
		sprintf(otdbug,"OTOpenEndpoint error: %d \n",err);
		MDebugXString(otdbug);
		gOpenConnects = index;
		return(-1);
	}

#ifdef USEASYNC
	if (!gProcPtrs[index]) {
		if (index == 0)	
			gProcPtrs[index] = NewOTNotifyUPP(EventHandler);
		else
			gProcPtrs[index] = NewOTNotifyUPP(EventHandler2);
	}
	err = OTInstallNotifier(ep,gProcPtrs[index], 0);
	if (err != kOTNoError) {
		gEPref[index] = 0;
		Com_Printf("NET_OT ERR: Can't install event handler\n");
		sprintf(otdbug,"OTInstallNotifier error: %d \n",err);
		MDebugXString(otdbug);
		gOpenConnects = index;
		return(-1);	
	}
	OTSetSynchronous(ep);
#else
	OTSetBlocking(ep);	// NCT was nonblocking
#endif
	err = OTInetGetInterfaceInfo(&myInfo,0);
	ourIPAddress = myInfo.fAddress;
	gBroadcastAddress = myInfo.fBroadcastAddr;

#ifdef USEASYNC
	OTSetAsynchronous(ep);
#endif
	
	err = DoStaticBind(gEPref[index], index);
	if (err != kOTNoError)
	{
		sprintf(otdbug,"DoStaticBind error: %d \n",err);
		MDebugXString(otdbug);
		if (err == kOTLookErr)
		{
			err = OTLook(ep);
			sprintf(otdbug,"OTLook error: %d \n",err);
			MDebugXString(otdbug);
			if (err == T_UDERR)
			{
				OTRcvUDErr(ep,&uderr);
				sprintf(otdbug,"OTRcvUDErr %d \n",uderr.error);
				MDebugXString(otdbug);
			}
		}
		gEPref[index] = 0;
		gOpenConnects = index;
		return(-1);	
	}
	return(index+ID_CONST);
	
}

static char dumpdata[2048];	//NCT_CHANGE 6/19/99 moved outside of OT_KillUDP to be static
static char dumpaddr[4];
static Word16 dumpport;
// ------------------------------------------------------
void OT_KillUDP(int conref)
{
EndpointRef ep;
OSStatus err;

	MDebugXString("OT_KillUDP === \n");

	// note, at the moment these have to be killed stack style,
	// LIFO....
	MDebugXString("Calling OT_KillUDP\n");
	ep = gEPref[conref];
	if (ep == NULL)
		return;

	// make sure there is no data pending...can't unbind when there is
	while ( OT_GetUDP((conref += ID_CONST),(Word8 *)dumpdata,sizeof(dumpdata),(Word8 *)dumpaddr,&dumpport) != -1)
		;

	gUnbindCompleted = 0;
	
	err = OTUnbind(ep);
	if (err != kOTNoError)
	{
		sprintf(otdbug,"OTUnbind error: %d \n",err);
		MDebugXString(otdbug);
		if (err == kOTLookErr)
		{
			err = OTLook(ep);
			sprintf(otdbug,"OTLook error: %d \n",err);
			MDebugXString(otdbug);
			if (err == T_UDERR)
			{
				OTRcvUDErr(ep,&uderr);
				sprintf(otdbug,"OTRcvUDErr %d \n",uderr.error);
				MDebugXString(otdbug);
			}
		}	
		else
			Com_Printf("NET_OT ERR: Unbind error\n");
	}		
	else
	{
		while (gUnbindCompleted == 0)
		{
		}
	}
	
	if (ep != NULL)
	{
#ifdef USEASYNC	
		OTRemoveNotifier(ep);
#endif
		err = OTCloseProvider(ep);
		if (err != kOTNoError)
			Com_Printf("NET_OT ERR: OTCloseProvider failed\n");
	}
	--gOpenConnects;
	gEPref[conref] = NULL;
	if (gProcPtrs[conref]) {
		DisposeOTNotifyUPP(gProcPtrs[conref]);
		gProcPtrs[conref] = 0;
	}
}
// ------------------------------------------------------
/*******************************************************************************
** DoStaticBind
********************************************************************************/

OSStatus DoStaticBind(EndpointRef ep, int index)
{
	TBind		req, ret;
	OSStatus 	err;

	// bind udp to current address and port 2001
	req.addr.len = sizeof(struct InetAddress);
	req.addr.buf = (unsigned char *) &gConAddress[index];
	req.qlen = 1;										// don't care for udp
	ret.addr.maxlen = sizeof(struct InetAddress);
	ret.addr.buf = (unsigned char *) &gRealConAddress[index];

	err = OTBind(ep, &req, &ret);
	if ( err != kOTNoError )
	{
		Com_Printf("NET_OT ERR: DoStaticBind\n");
		sprintf(otdbug,"OTBind error: %d \n",err);
		MDebugXString(otdbug);
		return err;
	}
	while (gBindCompleted == 0)
	{
	}
	gBindCompleted = 0;
	return err;
}
/*******************************************************************************
** DoGetInterfaceInfo
********************************************************************************/

OSStatus DoGetInterfaceInfo(SInt32 i)
{
	OSStatus			err;
	InetInterfaceInfo	myInfo;
	union
	{
		InetHost	addr;
		UInt8		bytes[4];
	} tmpAddr;
	
	do {
		FastMemSet(&myInfo, 0, sizeof(InetInterfaceInfo));
		err = OTInetGetInterfaceInfo(&myInfo, i);
		if (err != kOTNoError) {
			if (err == kOTNotFoundErr) {
				Debug::Message("Interface %d: Does Not Exist\n", i);
				break;
			} else {
				Debug::Message("Error! GetInterfaceInfo returns %d\n", err);
				break;
			}
		}
		tmpAddr.addr = myInfo.fAddress;
		gBroadcastAddress = myInfo.fBroadcastAddr;
/*
		fprintf(stderr, "Interface %d : Address = %d.%d.%d.%d\n ", i, tmpAddr.bytes[0],
				tmpAddr.bytes[1], tmpAddr.bytes[2], tmpAddr.bytes[3]);
		tmpAddr.addr = myInfo.fNetmask;
		fprintf(stderr, "Netmask = %d.%d.%d.%d\n ",  tmpAddr.bytes[0],
				tmpAddr.bytes[1], tmpAddr.bytes[2], tmpAddr.bytes[3]);
		tmpAddr.addr = myInfo.fBroadcastAddr;
		fprintf(stderr, "Broadcast Address = %d.%d.%d.%d\n",  tmpAddr.bytes[0],
				tmpAddr.bytes[1], tmpAddr.bytes[2], tmpAddr.bytes[3]);
		fprintf(stderr, "\n");
*/
	} while ( FALSE );
	
	return err;
}
/*******************************************************************************
** EventHandler
********************************************************************************/

pascal void EventHandler(void*, OTEventCode event, OTResult, void*)
{

	if (event == T_DATA)
	{
		gDataToRead = 1;
		return;
	}
	else if (event == T_BINDCOMPLETE)
	{
		gBindCompleted = 1;
		//MDebugXString("BINDCOMPLETE\n");
		return;
	}
	else if (event == T_UNBINDCOMPLETE)
	{
		gUnbindCompleted = 1;
	}
	else
	{
		switch (event) {
			case T_LISTEN:	MDebugXString("Got T_LISTEN\n");
							break;
			case T_CONNECT:	MDebugXString("Got T_CONNECT\n");
							break;
			case T_EXDATA:	MDebugXString("Got T_EXDATA\n");
							break;
			case T_DISCONNECT:	MDebugXString("Got T_DISCONNECT\n");
							break;
			case T_ERROR:	MDebugXString("Got T_ERROR\n");
							break;
			case T_UDERR:	MDebugXString("Got T_UDERROR1 !!!!!\n");
							OTRcvUDErr(gEPref[0],&uderr);
							break;
			case T_ORDREL:	MDebugXString("Got T_ORDREL\n");
							break;
			case T_GODATA:	MDebugXString("Got T_GODATA\n");
							break;
			case T_GOEXDATA:	MDebugXString("Got T_GOEXDATA\n");
							break;
			case T_REQUEST:	MDebugXString("Got T_REQUEST\n");
							break;
			case T_REPLY:	MDebugXString("Got T_REPLY\n");
							break;
			case T_PASSCON:	MDebugXString("Got T_PASSCON\n");
							break;
			case T_RESET:	MDebugXString("Got T_RESET\n");
							break;

			case T_BINDCOMPLETE:	MDebugXString("Got T_BINDCOMPLETE\n");
									break;
			case T_ACCEPTCOMPLETE:	MDebugXString("Got T_ACCEPTCOMPLETE\n");
									break;
			case T_REPLYCOMPLETE:	MDebugXString("Got T_REPLYCOMPLETE\n");
									break;
			case T_DISCONNECTCOMPLETE:	MDebugXString("Got T_DISCONNECTCOMPLETE\n");
									break;
			case T_OPTMGMTCOMPLETE:	MDebugXString("Got T_OPTMGMTCOMPLETE\n");
									break;
			case T_OPENCOMPLETE:	MDebugXString("Got T_OPENCOMPLETE\n");
									break;
			case T_GETPROTADDRCOMPLETE:	MDebugXString("Got T_PROTADDRCOMPLETE\n");
									break;
			case T_RESOLVEADDRCOMPLETE:	MDebugXString("Got T_RESOLVEADDRCOMPLETE\n");
									break;
			case T_GETINFOCOMPLETE:	MDebugXString("Got T_GETINFOCOMPLETE\n");
									break;
			case T_SYNCCOMPLETE:	MDebugXString("Got T_SYNCCOMPLETE\n");
									break;
			case T_MEMORYRELEASED:	MDebugXString("Got T_MEMORYRELEASED\n");
									break;
			case T_REGNAMECOMPLETE:	MDebugXString("Got T_REGNAMECOMPLETE\n");
									break;
			case T_DELNAMECOMPLETE:	MDebugXString("Got T_DELNAMECOMPLETE\n");
									break;
			case T_LKUPNAMECOMPLETE:	MDebugXString("Got T_LKUPNAMECOMPLETE\n");
									break;
			case T_LKUPNAMERESULT:	MDebugXString("Got T_LKUPNAMERESULT\n");
									break;
		
		}
	}
	return;
}
/*******************************************************************************
** EventHandler2
********************************************************************************/

pascal void EventHandler2(void*, OTEventCode event, OTResult, void*)
{
	if (event == T_DATA) {
		gDataToRead2 = 1;
		return;
	} else if (event == T_BINDCOMPLETE) {
		gBindCompleted = 1;
		//MDebugXString("BINDCOMPLETE\n");
		return;
	} else if (event == T_UNBINDCOMPLETE) {
		gUnbindCompleted = 1;
	} else {
		switch (event) {
		case T_LISTEN:	MDebugXString("Got T_LISTEN\n");
			break;
		case T_CONNECT:	MDebugXString("Got T_CONNECT\n");
			break;
		case T_EXDATA:	MDebugXString("Got T_EXDATA\n");
			break;
		case T_DISCONNECT:	MDebugXString("Got T_DISCONNECT\n");
			break;
		case T_ERROR:	MDebugXString("Got T_ERROR\n");
			break;
		case T_UDERR:	MDebugXString("Got T_UDERROR2!!!!\n");
			OTRcvUDErr(gEPref[1],&uderr);
			break;
		case T_ORDREL:	MDebugXString("Got T_ORDREL\n");
			break;
		case T_GODATA:	MDebugXString("Got T_GODATA\n");
			break;
		case T_GOEXDATA:	MDebugXString("Got T_GOEXDATA\n");
			break;
		case T_REQUEST:	MDebugXString("Got T_REQUEST\n");
			break;
		case T_REPLY:	MDebugXString("Got T_REPLY\n");
			break;
		case T_PASSCON:	MDebugXString("Got T_PASSCON\n");
			break;
		case T_RESET:	MDebugXString("Got T_RESET\n");
			break;

		case T_BINDCOMPLETE:	MDebugXString("Got T_BINDCOMPLETE\n");
			break;
		case T_ACCEPTCOMPLETE:	MDebugXString("Got T_ACCEPTCOMPLETE\n");
			break;
		case T_REPLYCOMPLETE:	MDebugXString("Got T_REPLYCOMPLETE\n");
			break;
		case T_DISCONNECTCOMPLETE:	MDebugXString("Got T_DISCONNECTCOMPLETE\n");
			break;
		case T_OPTMGMTCOMPLETE:	MDebugXString("Got T_OPTMGMTCOMPLETE\n");
			break;
		case T_OPENCOMPLETE:	MDebugXString("Got T_OPENCOMPLETE\n");
			break;
		case T_GETPROTADDRCOMPLETE:	MDebugXString("Got T_PROTADDRCOMPLETE\n");
			break;
		case T_RESOLVEADDRCOMPLETE:	MDebugXString("Got T_RESOLVEADDRCOMPLETE\n");
			break;
		case T_GETINFOCOMPLETE:	MDebugXString("Got T_GETINFOCOMPLETE\n");
			break;
		case T_SYNCCOMPLETE:	MDebugXString("Got T_SYNCCOMPLETE\n");
			break;
		case T_MEMORYRELEASED:	MDebugXString("Got T_MEMORYRELEASED\n");
			break;
		case T_REGNAMECOMPLETE:	MDebugXString("Got T_REGNAMECOMPLETE\n");
			break;
		case T_DELNAMECOMPLETE:	MDebugXString("Got T_DELNAMECOMPLETE\n");
			break;
		case T_LKUPNAMECOMPLETE:	MDebugXString("Got T_LKUPNAMECOMPLETE\n");
			break;
		case T_LKUPNAMERESULT:	MDebugXString("Got T_LKUPNAMERESULT\n");
			break;
		}
	}
	return;
}
