#include "mac_version.h"
#include "mac_isp.h"
#include <Quickdraw.h>
#include <Dialogs.h>
#include <Gestalt.h>

#define alrt_Mem 3835

Word BypassPlug;
Word WagesOfSin;

static char *TitleString = "Sin";
#if defined(SIN_DEMO)
static char SprocketsURL[] = "http://asu.info.apple.com/swupdates.nsf/artnum/n11848";
//static char QuicktimeURL[] = "http://www.quicktime.com/";
#else
static char SprocketsInstaller[] = ":Sin:System files:Game Sprockets 1.7.5:installer";
//static char QuicktimeInstaller[] = ":Sin:System files:Quicktime 4.1.2:QuickTime installer";
static char IndeoFile[] = ":Sin:System files:Intel Indeo Video 5:Indeo Video5";
#endif

/**********************************

	Launch an app

**********************************/

static void MacLaunchFromCD(const char *name )
{
	while (!Burger::FileManager::DoesFileExist(name)) {
		MacOSEjectCD();
		if (!OkCancelAlertMessage("CD missing","Please insert your game CD")) {
			return;
		}
	}
	Burger::Filename MyFilename;
	MyFilename.ToNative(name);
	MacLaunch(MyFilename.GetVRefNum(),MyFilename.GetDirID(),MyFilename.GetPtr(),FALSE);
	OkAlertMessage(Debug::GetErrorMsg(),"Launch error");
}

/**********************************

	This checks various OS crap we need to check for our game
	returns TRUE if we can play, FALSE if not

**********************************/

int CheckOSCompatibility(void)
{
	long lRAMval;
	OSErr err;

	Input_Suspend();
	ShowCursor();

	// Check if system has less than 80 megs of 'logical' RAM (Physical+VM)
	err = Gestalt(FOUR_CHAR_CODE('lram'), &lRAMval);
	if (err == noErr) {
		if (lRAMval < (80*1024*1024)) {
			if (CautionAlert(alrt_Mem, NULL) == 4) {
				MacOpenControlPanel('mmry',"Memory",FALSE);
				return(FALSE);
			}
		}
	}

	if (Burger::Mac::GetOSVersion()<0x860) {
		OkAlertMessage("This game requires MacOS 8.6 or later","Old MacOS!");
		return FALSE;
	}

	if (Burger::Mac::GetDrawSprocketVersion()<0x175) {
#if !defined(SIN_DEMO)
		OkAlertMessage("This game requires DrawSprocket 1.7.5 or later, installing the game sprockets may reboot your computer",TitleString);
		MacLaunchFromCD(SprocketsInstaller);
#else
		OkAlertMessage("This game requires DrawSprocket 1.7.5 or later, please download and install it.",TitleString);
		Globals::LaunchURL(SprocketsURL);
#endif
		return FALSE;
	}

#if !TARGET_API_MAC_CARBON
	if (Burger::Mac::GetInputSprocketVersion()<0x173) {
#if !defined(SIN_DEMO)
		OkAlertMessage("This game requires InputSprocket 1.7.3 or later, installing the game sprockets may reboot your computer",TitleString);
		MacLaunchFromCD(SprocketsInstaller);
#else
		OkAlertMessage("This game requires InputSprocket 1.7.3 or later, please download and install it.",TitleString);
		Globals::LaunchURL(SprocketsURL);
#endif
		return FALSE;
	}
#endif

	/* Check the free memory amount */

#if !TARGET_API_MAC_CARBON
	if (TempFreeMem() < 32*1024*1024) {		/* Need memory for GL */
		if (StopAlert(129,NULL)==2) {
			MacOpenControlPanel('mmry',"Memory",FALSE);
		}
		return FALSE;
	}
#endif

#if !defined(SIN_DEMO) && !TARGET_API_MAC_CARBON
	MacOSSetExtensionsPrefix(30);
	if (!Burger::FileManager::DoesFileExist("30:Indeo Video5")) {
		if (Burger::FileManager::CopyFile("30:Indeo Video5",IndeoFile)) {
			OkAlertMessage("Please copy the Indeo Video5 file from your CD into "
				"your system folder. This game requires this extension","Indeo missing");
			return FALSE;
		}
	}
#endif
	if (!Burger::FileManager::SaveFile("9:Test.txt","Testing",7)) {
		OkAlertMessage("I cannot save data to this drive. Please install "
			"this game onto your hard drive.","File error");
		return FALSE;
	}
	Burger::FileManager::DeleteFile("9:Test.txt");

#if defined(_DEBUG)
#define SCRFLAG 0
#else
#define SCRFLAG 1
#endif

	/* Shameless plug screens */
	
#if 1
	if (!BypassPlug) {
		if (!SetDisplayToSize(640,480,16,SCRFLAG)) {		/* Do I have 8 bit video? */
			Image_t MyImage;
			void *Work;
			Word i;
			HideCursor();
			ResetLastTick();
			Work = Burger::FileManager::LoadFile("9:Base:Pics:MacPlay.gif",0);
			WaitTicks(2*TICKSPERSEC);			/* Wait for video to stablize */
			KeyboardKbhit();
			if (Work) {
				i = ImageParseGIF(&MyImage,(Word8*)Work);
				Burger::Free(Work);
				if (!i) {
					PaletteMake16BitLookup(Table8To16,MyImage.PalettePtr,VideoColorDepth);
					LockVideoPage();
					DrawShapeLowLevelTo16(0,0,MyImage.Width,MyImage.Height,MyImage.RowBytes-MyImage.Width,MyImage.ImagePtr);
					UpdateAndPageFlip();
					ImageDestroy(&MyImage);
					ResetLastTick();
					WaitTicks(2*TICKSPERSEC);
				}
			}

			Work = Burger::FileManager::LoadFile("9:Base:Pics:Contralogo.gif",0);
			if (Work) {
				i = ImageParseGIF(&MyImage,(Word8*)Work);
				Burger::Free(Work);
				if (!i) {
					PaletteMake16BitLookup(Table8To16,MyImage.PalettePtr,VideoColorDepth);
					LockVideoPage();
					DrawShapeLowLevelTo16(0,0,MyImage.Width,MyImage.Height,MyImage.RowBytes-MyImage.Width,MyImage.ImagePtr);
					UpdateAndPageFlip();
					ImageDestroy(&MyImage);
					ResetLastTick();
					WaitTicks(2*TICKSPERSEC);
				}
			}
		} else {
			return FALSE;
		}
	}
#endif
	Input_Resume();
	return(TRUE);
}

