/**********************************

	Contains:	Functions to enable Mac OS device gamma adjustments using Windows common 3 channel 256 element 8 bit gamma ramps

	Written by:	Geoff Stahl

	Copyright:	Copyright  1999 Apple Computer, Inc., All Rights Reserved

	This code is MAC ONLY!!!
	
**********************************/

#ifndef __MACGAMMA_H__
#define __MACGAMMA_H__

#ifndef __BURGER__
#include <burger.h>
#endif

#ifndef __QDOFFSCREEN__
#include <QDOffscreen.h>
#endif

// structures/classes -----------------------------------------------
	
typedef struct recDeviceGamma {									// storage for device handle and gamma table
	GDHandle hGD;												// handle to device
	GammaTblPtr pDeviceGamma;									// pointer to device gamma table
} recDeviceGamma;

typedef struct recSystemGamma {		// storage for system devices and gamma tables
	Word numDevices;				// number of devices
	recDeviceGamma **devGamma;		// array of pointers to device gamma records
} recSystemGamma;

#ifdef __cplusplus
extern "C" {
#endif

extern Byte *MacGetSystemGammas(void);											
extern void MacRestoreSystemGammas(Byte *pSystemGammas);					
extern void MacDisposeSystemGammas(Byte *pSystemGammas);
extern Word MacGetDeviceGammaRampGD(GDHandle hGD,Byte *pRamp);
extern Word MacSetDeviceGammaRampGD(GDHandle hGD,const Byte *pRamp);

#ifdef __cplusplus
}
#endif

#endif
