#ifndef __MODELESSDLOG_H__
#define __MODELESSDLOG_H__

#ifndef __BURGER__
#include <burger.h>
#endif

#include <Events.h>

#define MAX_MDU_DLOGS	16
#define kModelessID		0x0DE1E55L

enum {
	kMDItem_Override = 1,
	kMDItem_EditTextNumber = 2
};
	
struct MDCtlTemplate {
	Word32		itemID;
	Word32		itemType;
	Word32		itemFlags;		// Override automatic handling bit...
	Word32		itemFamily;		// family number for radio buttons..
	Word32		*itemValue;		// pointer to variable to update status on...
	void (*clickCallback)(EventRecord *clickEvent, short theItem);
	void (*itemDraw)();
};	

typedef struct MDCtlTemplate MDCtlTemplate;


struct MDTemplate {
	DialogPtr		theDialog;
	Word32			theFlags;
	Word32			selectedEditText;
	Word32			numItems;
	Bool			areEditText;
	MDCtlTemplate	*firstCtl;
	void (*closeCallback)();
	void (*contentDraw)();
	void (*controlCallback)(EventRecord *clickEvent, short theItem);
};

typedef struct MDTemplate MDTemplate;	

// Function prototypes

void MDU_Init(void);
int MDU_RegisterDialog(MDTemplate *dialogTemp);
void MDU_ReleaseDialog(int dialogRef);
void MDU_ShowDialog(int dialogRef);
void MDU_HideDialog(int dialogRef);
void MDU_SetCtlTemplate(MDCtlTemplate *ctl, Word32 ctlID,
						Word32 ctlType, Word32 ctlFlags,
						Word32 ctlFamily, Word32 *ctlValue,
						void (*clickCallback)(EventRecord *clickEvent, short theItem),
						void (*itemDraw)());
	

// Event loop handler routines...

Bool MDU_HandleKey(EventRecord *theEvent);
Bool MDU_HandleIdle(EventRecord *theEvent);
Bool MDU_HandleClick(EventRecord *theEvent);

Bool MDU_IsDialog(EventRecord *theEvent);
Bool MDU_HandleUpdate(EventRecord *theEvent);
Bool MDU_HandleClose(EventRecord *theEvent);
Bool MDU_HandleDrag(EventRecord *theEvent);

#endif