#ifndef __RW_MAC_H__
#define __RW_MAC_H__

#ifndef __BURGER__
#include <burger.h>
#endif

#ifndef __Q_SHARED_H__
#include "q_shared.h"
#endif

typedef void (*Key_Event_fp_t)(int key, qboolean down);

extern void (*KBD_Update_fp)(void);
extern void (*KBD_Init_fp)(Key_Event_fp_t fp);
extern void (*KBD_Close_fp)(void);

typedef struct in_state {
	// Pointers to functions back in client, set by vid_so
	void (*IN_CenterView_fp)(void);
	Key_Event_fp_t Key_Event_fp;
	vec_t *viewangles;
	int *in_strafe_state;
} in_state_t;

/* In IN_Mac.c */

extern qboolean mlooking;

extern void KBD_Init(Key_Event_fp_t fp);
extern void KBD_Update(void);
extern void KBD_Flush(void);
extern void KBD_Close(void);
extern void RW_IN_Init(in_state_t *in_state_p);
extern void RW_IN_Shutdown(void);
extern void RW_IN_Commands (void);
extern void RW_IN_Move (usercmd_t *cmd);
extern void RW_IN_Frame (void);
extern void RW_IN_Activate(qboolean active);

/* In IN_Joy.c */

extern void IN_StartupJoystick(void);
extern void IN_JoyMove(usercmd_t *cmd);

/* In Mac_Shared.c */

extern void InitBackground(void);
extern void KillBackground(void);
extern void Mac_Desktop_f(void);
extern void Mac_Resume_f(void);
extern int fprintfx(FILE * file, const char * format, ...);

/* In Mac_Misc.c */

/* In Sys_Mac.c */

extern int gMacBackground;	/* If this is true, game is in background, so don't collect input */

/* In Vid_Mac.c */

extern int gIn_Active;		/* If this is false, we're in background, so don't collect input */

extern void (*RW_IN_Init_fp)(in_state_t *in_state_p);
extern void (*RW_IN_Shutdown_fp)(void);
extern void (*RW_IN_Activate_fp)(qboolean active);
extern void (*RW_IN_Commands_fp)(void);
extern void (*RW_IN_Move_fp)(usercmd_t *cmd);
extern void (*RW_IN_Frame_fp)(void);

#endif