
// mac_snddma.c
// all other sound mixing is portable

#include <burger.h>
#include "client.h"
#include "snd_loc.h"
#include "mac_snd.h"

/*
===============
SNDDMA_Init
===============
*/
qboolean SNDDMA_Init(void) {
int res;

	dma.channels = 2;
	dma.samples = MAX_MIXED_SAMPLES;
	dma.submission_chunk = SUBMISSION_CHUNK;
	dma.samplebits = 16;
	
	if (s_khz->value == 44)
		dma.speed = 44100;
	if (s_khz->value == 22)
		dma.speed = 22050;
	if (s_khz->value == 11)
		dma.speed = 11025;
		
	s_samplerate = dma.speed;

	dma.buffer = (byte *)s_mixedSamples;

	dma.samplepos = 0;

	Com_Printf("Opening Sound Manager channel...\n");
	res = MacSoundInit();
	if (res == TRUE)
		Com_Printf("   %d channels(s)\n   %d bits/sample\n   %d bytes/sec\n",
					dma.channels, dma.samplebits, dma.speed);
	else
		Com_Printf("Couldn't initialize sound channel\n");
		
	return(res);
}

/*
===============
SNDDMA_GetDMAPos
===============
*/
int	SNDDMA_GetDMAPos(void) {
	return s_chunkCount * SUBMISSION_CHUNK;
}

/*
===============
SNDDMA_Shutdown
===============
*/
void SNDDMA_Shutdown(void) {
	Com_Printf("Shutting down sound channel\n");
	MacSoundShutdown();
}

/*
===============
SNDDMA_BeginPainting
===============
*/
void SNDDMA_BeginPainting(void) {
}

/*
===============
SNDDMA_Submit
===============
*/
void SNDDMA_Submit(void) {
}



