//-----------------------------------------------------------------------------
//
// Copyright (C) 1998 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// DESCRIPTION:
//

#include "gl_local.h"
#include "client.h"

#ifdef SIN
#include "gl_sinmdl.h"
#include "r_sinmdl.h"
#include <ctype.h>
#ifdef __A3D_GEOM
void A3D_RenderGeometry (void *pA3D, void *pGeom, void *pMat, void *pGeomStatus);
#endif

#endif

extern int gIsOpenGL;

extern refexport_t GL_GetRefAPI (refimport_t rimp );

void R_Clear (void);
float ColorNormalize (vec3_t in, vec3_t out);
extern void MYgluPerspective( GLdouble fovy, GLdouble aspect, GLdouble zNear, GLdouble zFar );

gl_viddef_t	gl_vid;
extern refimport_t	ri;
extern model_t		*r_worldmodel;
float		gldepthmin, gldepthmax;
glconfig_t gl_config;
glstate_t gl_state;

image_t		*r_notexture;		// use for bad textures
image_t		*r_particletexture;	// little dot for particles
#ifdef SIN
image_t *r_specular;
extern image_t *r_envmap;
extern image_t *r_goldenvmap;
// 2015 code
extern image_t *r_gogglesmap;
#endif

extern entity_t	*currententity;
extern model_t		*currentmodel;
extern int			r_visframecount;	// bumped when going to a new PVS
extern int			r_framecount;		// used for dlight push checking

cplane_t	frustum[4];

int			c_brush_polys, c_alias_polys;

float		v_blend[4];			// final blending color

void GL_Strings_f( void );

//
// view origin
//

float	r_world_matrix[16];
float	r_base_world_matrix[16];

//
// screen size info
//

extern refdef_t	r_newrefdef;
extern vec3_t	vup;
extern vec3_t	vpn;
extern vec3_t	vright;
extern vec3_t	r_origin;
extern int r_viewcluster;
extern int r_oldviewcluster;
extern cvar_t	*r_drawentities;
extern cvar_t	*r_drawworld;
extern cvar_t	*r_speeds;
extern cvar_t	*r_fullbright;
extern cvar_t	*r_novis;
extern cvar_t	*r_lerpmodels;
extern cvar_t	*r_lefthand;
extern cvar_t	*r_lightlevel;	// FIXME: This is a HACK to get the client's light level

int r_viewcluster2,r_oldviewcluster2;

cvar_t	*r_norefresh;
cvar_t	*r_nocull;

cvar_t	*gl_nosubimage;
cvar_t	*gl_allow_software;

cvar_t   *gl_vertex_arrays;

cvar_t	*gl_particle_min_size;
cvar_t	*gl_particle_max_size;
cvar_t	*gl_particle_size;
cvar_t	*gl_particle_att_a;
cvar_t	*gl_particle_att_b;
cvar_t	*gl_particle_att_c;

cvar_t	*gl_ext_swapinterval;
cvar_t	*gl_ext_multitexture;
cvar_t	*gl_ext_pointparameters;
cvar_t	*gl_ext_compiled_vertex_array;

cvar_t	*gl_log;
cvar_t	*gl_bitdepth;
cvar_t	*gl_drawbuffer;
cvar_t	*gl_lightmap;
cvar_t	*gl_shadows;
cvar_t	*gl_dynamic;
cvar_t  *gl_monolightmap;
cvar_t	*gl_modulate;
cvar_t	*gl_nobind;
cvar_t	*gl_round_down;
cvar_t	*gl_skymip;
cvar_t	*gl_showtris;
cvar_t	*gl_ztrick;
cvar_t	*gl_clear;
cvar_t	*gl_cull;
cvar_t	*gl_polyblend;
cvar_t	*gl_flashblend;
cvar_t	*gl_playermip;
cvar_t  *gl_saturatelighting;
cvar_t	*gl_swapinterval;
cvar_t	*gl_texturemode;
cvar_t   *gl_texturealphamode;
cvar_t  *gl_texturesolidmode;
cvar_t  *gl_lockpvs;

#ifdef SIN
cvar_t   *gl_drawflat;
cvar_t	*gl_draworder;
cvar_t	*gl_skintexturemode;
#endif
cvar_t	*gl_3dlabs_broken;

#ifdef SIN
cvar_t	*gl_showportals;
cvar_t   *r_detailthresh;
cvar_t   *gl_showents;

//2015 code
extern cvar_t *r_conchars;
extern cvar_t *r_condist;
extern cvar_t *r_conoffset;
extern cvar_t *r_conthresh;
extern cvar_t *r_detaildist;
extern cvar_t *r_monolighting;
extern cvar_t   *game2015;
#endif


/*
=================
R_CullBox

Returns TRUE if the box is completely outside the frustom
=================
*/

#ifndef AMD3D

qboolean R_CullBox (vec3_t mins, vec3_t maxs)
{
	int		i;

	if (r_nocull->value)
		return FALSE;

	for (i=0 ; i<4 ; i++)
      if ( BOX_ON_PLANE_SIDE(mins, maxs, &frustum[i]) == 2)
			return TRUE;
	return FALSE;
}

#endif


void R_RotateForEntity (entity_t *e)
{
#if 0
//#if SIN
	 float m[16];

	 VectorCopy( e->mat[0], (&m[0]) );
	 VectorCopy( e->mat[1], (&m[4]) );
	 VectorCopy( e->mat[2], (&m[8]) );
	 VectorCopy( e->origin, (&m[12]) );
	 m[3] = m[7] = m[11] = 0;
	 m[15] = 1;
	 qglMultMatrixf( m );
#else
    qglTranslatef (e->origin[0],  e->origin[1],  e->origin[2]);

    qglRotatef (e->angles[1],  0, 0, 1);
    qglRotatef (-e->angles[0],  0, 1, 0);
    qglRotatef (-e->angles[2],  1, 0, 0);
#endif
}

/*
=============================================================

  SPRITE MODELS

=============================================================
*/


#ifdef SIN
/*
=================
R_DrawSpriteModel

=================
*/
void R_DrawSpriteModel (entity_t *e)
   {
	vec3_t	      point;
	dsprframe_t    *frame;
	int				i;
	dsprite_t		*psprite;
	//vec3_t			tvec;
	float		   	dot, angle, sr, cr;
	vec3_t			svup, svright, svpn, origin;	// in worldspace
	vec3_t			scaled_svright, scaled_svup;
   float          alpha=1.0f;
   int            num_sprites=1;
   float          yaw_inc;
   vec3_t         angles;
   qboolean       sprite_lefthanded;

	// don't even bother culling, because it's just a single
	// polygon without a surface cache
	psprite = (dsprite_t *)currentmodel->extradata;
	e->frame %= psprite->numframes;
	frame = &psprite->frames[e->frame];

   alpha = frame->alpha;
   VectorCopy( currententity->angles, angles );

	if (psprite->type == SPR_FACING_UPRIGHT)
      {
	   // generate the sprite's axes, with vup straight up in worldspace, and
	   // svright perpendicular to modelorg.
	   // This will not work if the view direction is very close to straight up or
	   // down, because the cross product will be between two nearly parallel
	   // vectors and starts to approach an undefined state, so we don't draw if
	   // the two vectors are less than 1 degree apart

      // FIXME - What is modelorg?
#if 0
      tvec[0] = -modelorg[0];
		tvec[1] = -modelorg[1];
		tvec[2] = -modelorg[2];
		VectorNormalize (tvec);
		dot = tvec[2];	// same as DotProduct (tvec, svup) because
						//  svup is 0, 0, 1
		if ((dot > 0.999848) || (dot < -0.999848))	// cos(1 degree) = 0.999848
			return;
		svup[0] = 0;
		svup[1] = 0;
		svup[2] = 1;
		svright[0] = tvec[1];
								// CrossProduct(svup, -modelorg,
		svright[1] = -tvec[0];
								//              svright)
		svright[2] = 0;
		VectorNormalize (svright);
		svpn[0] = -svright[1];
		svpn[1] = svright[0];
		svpn[2] = 0;
					// CrossProduct (svright, svup,
					//  svpn)
#endif
	}
	else if (psprite->type == SPR_VP_PARALLEL)
	{
	// generate the sprite's axes, completely parallel to the viewplane. There
	// are no problem situations, because the sprite is always in the same
	// position relative to the viewer
		for (i=0 ; i<3 ; i++)
		{
			svup[i] = vup[i];
			svright[i] = vright[i];
			svpn[i] = vpn[i];
		}
	}
	else if (psprite->type == SPR_VP_PARALLEL_UPRIGHT)
	{
	// generate the sprite's axes, with vup straight up in worldspace, and
	// svright parallel to the viewplane.
	// This will not work if the view direction is very close to straight up or
	// down, because the cross product will be between two nearly parallel
	// vectors and starts to approach an undefined state, so we don't draw if
	// the two vectors are less than 1 degree apart
		dot = vpn[2];	// same as DotProduct (vpn, svup) because
						//  svup is 0, 0, 1
		if ((dot > 0.999848) || (dot < -0.999848))	// cos(1 degree) = 0.999848
			return;
		svup[0] = 0;
		svup[1] = 0;
		svup[2] = 1;
		svright[0] = vpn[1];
										// CrossProduct (svup, vpn,
		svright[1] = -vpn[0];	//  svright)
		svright[2] = 0;
		VectorNormalize (svright);
		svpn[0] = -svright[1];
		svpn[1] = svright[0];
		svpn[2] = 0;
					// CrossProduct (svright, svup,
					//  svpn)
	} else if (psprite->type == SPR_ORIENTED) {
		// generate the sprite's axes, according to the sprite's world orientation
		AngleVectors (currententity->angles, svpn, svright, svup);
	} else if (psprite->type == SPR_ORIENTED_CROSS) {
		// generate the sprite's axes, according to the sprite's world orientation
		AngleVectors (currententity->angles, svpn, svright, svup);
		yaw_inc = 90;
		num_sprites = 2;
	} else if (psprite->type == SPR_ORIENTED_STAR) {
		// generate the sprite's axes, according to the sprite's world orientation
		AngleVectors (currententity->angles, svpn, svright, svup);
		yaw_inc = 45;
		num_sprites = 4;
	} else if (psprite->type == SPR_VP_PARALLEL_ORIENTED) {
	// generate the sprite's axes, parallel to the viewplane, but rotated in
	// that plane around the center according to the sprite entity's roll
	// angle. So vpn stays the same, but vright and vup rotate
		angle = currententity->angles[ROLL] * (M_PI*2 / 360);
		sr = sin(angle);
		cr = cos(angle);

		for (i=0 ; i<3 ; i++) {
			svpn[i] = vpn[i];
			svright[i] = vright[i] * cr + vup[i] * sr;
			svup[i] = vright[i] * -sr + vup[i] * cr;
		}
	} else {
		Sys_Error ("R_DrawSprite: Bad sprite type %d", psprite->type);
	}

	sprite_lefthanded = FALSE;
	VectorCopy( e->origin, origin );
	if (currententity->flags & RF_WEAPONMODEL) {	// hack the depth range to prevent view model from poking into walls
		if ( r_lefthand->value == 2 )
			return;
		if ( r_lefthand->value == 1.0F )
			sprite_lefthanded = TRUE;
		if ( e->flags & RF_XFLIP )
			sprite_lefthanded ^= TRUE;
		if (sprite_lefthanded) {
			vec3_t delta;
			float len;
			VectorSubtract( e->origin, r_origin, delta );
			len = DotProduct( delta, vright );
			VectorMA( e->origin, -2*len, vright, origin );
		}
		qglDepthRange (gldepthmin, gldepthmin + 0.3*(gldepthmax-gldepthmin));
	}

	if ( currentmodel->skins[e->frame] )
		GL_BindImage( currentmodel->skins[e->frame] );
	else
		GL_BindImage( r_notexture );

	if ( psprite->twosided ) {
		qglDisable( GL_CULL_FACE );
	}

	qglDepthMask (0);
	qglEnable (GL_BLEND);
	GL_TexEnv( GL_MODULATE );
	qglDisable( GL_ALPHA_TEST );

	if ( psprite->flags & SPRITE_OVERBRIGHT )
		qglBlendFunc (GL_ONE, GL_ONE);
	else
		qglBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	if (e->flags & RF_TRANSLUCENT)
		alpha = e->alpha;

	if (e->flags & RF_LENSFLARE) {
		// Scale the colors by alpha, because we are adding instead of alpha blending
		e->color_r *= alpha;
		e->color_g *= alpha;
		e->color_b *= alpha;
		qglColor4f( e->color_r, e->color_g, e->color_b, alpha );
	} else if (psprite->flags & SPRITE_WORLDLIT) {
		vec3_t	     c;
		GL_R_LightPoint(origin, c, TRUE);
		qglColor4f(c[0],c[1],c[2],alpha);
	} else if (psprite->flags & SPRITE_MODULATE) {
		qglColor4f( e->color_r, e->color_g, e->color_b, alpha );
	} else {
		qglColor4f( 1,1,1, alpha );
	}

   if ( psprite->flags & SPRITE_HASBASE )
      {
   	vec3_t   up, right, forward;
   	frame = &psprite->base;

		AngleVectors (currententity->angles, up, right, forward);

	   GL_BindImage( currentmodel->skins[ psprite->numframes ] );
		// Scale the sprite
		VectorScale( right, psprite->scale * e->scale, scaled_svright );
		VectorScale( up, psprite->scale * e->scale, scaled_svup );

      qglBegin (GL_QUADS);

	   qglTexCoord2f (0, 1);
	   VectorMA (origin, -frame->origin_y, scaled_svup, point);
	   VectorMA (point, -frame->origin_x, scaled_svright, point);
	   qglVertex3fv (point);

	   qglTexCoord2f (0, 0);
	   VectorMA (origin, frame->height - frame->origin_y, scaled_svup, point);
	   VectorMA (point, -frame->origin_x, scaled_svright, point);
	   qglVertex3fv (point);

	   qglTexCoord2f (1, 0);
	   VectorMA (origin, frame->height - frame->origin_y, scaled_svup, point);
	   VectorMA (point, frame->width - frame->origin_x, scaled_svright, point);
	   qglVertex3fv (point);

	   qglTexCoord2f (1, 1);
	   VectorMA (origin, -frame->origin_y, scaled_svup, point);
	   VectorMA (point, frame->width - frame->origin_x, scaled_svright, point);
	   qglVertex3fv (point);

      qglEnd ();

   	frame = &psprite->frames[e->frame];
   	GL_BindImage( currentmodel->skins[e->frame] );
      }

   qglBegin (GL_QUADS);

	for (i=0;i<num_sprites;i++)
      {
      if (i > 0)
         {
         if ( yaw_inc == 90 )
            {
            vec3_t swap;
            VectorCopy(svpn, swap);
            VectorCopy(svright, svpn);
            VectorCopy(swap, svright);
            }
         else
            {
            angles[ YAW ] += yaw_inc;
            while ( angles[ YAW ] >= 360 )
               angles[ YAW ] -= 360;
   		   AngleVectors( angles, svpn, svright, svup );
            }
         }

		// Scale the sprite
		VectorScale( svright, psprite->scale * e->scale, scaled_svright );
		VectorScale( svup, psprite->scale * e->scale, scaled_svup );

	   qglTexCoord2f (0, 1);
	   VectorMA (origin, -frame->origin_y, scaled_svup, point);
	   VectorMA (point, -frame->origin_x, scaled_svright, point);
	   qglVertex3fv (point);

	   qglTexCoord2f (0, 0);
	   VectorMA (origin, frame->height - frame->origin_y, scaled_svup, point);
	   VectorMA (point, -frame->origin_x, scaled_svright, point);
	   qglVertex3fv (point);

	   qglTexCoord2f (1, 0);
	   VectorMA (origin, frame->height - frame->origin_y, scaled_svup, point);
	   VectorMA (point, frame->width - frame->origin_x, scaled_svright, point);
	   qglVertex3fv (point);

	   qglTexCoord2f (1, 1);
	   VectorMA (origin, -frame->origin_y, scaled_svup, point);
	   VectorMA (point, frame->width - frame->origin_x, scaled_svright, point);
	   qglVertex3fv (point);
      }
   qglEnd ();

	qglDepthMask (1);
	qglBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	qglDisable (GL_BLEND);
	GL_TexEnv( GL_REPLACE );
	qglDisable (GL_ALPHA_TEST);
	qglColor4f( 1, 1, 1, 1 );

	if (currententity->flags & RF_WEAPONMODEL) // hack the depth range to prevent view model from poking into walls
	   qglDepthRange (gldepthmin, gldepthmax);

	if ( psprite->twosided )
		{
      qglEnable( GL_CULL_FACE );
		}
}

#else

/*
=================
R_DrawSpriteModel

=================
*/
void R_DrawSpriteModel (entity_t *e)
{
	float alpha = 1.0F;
	vec3_t	point;
	dsprframe_t	*frame;
	float		*up, *right;
	dsprite_t		*psprite;

	// don't even bother culling, because it's just a single
	// polygon without a surface cache

	psprite = (dsprite_t *)currentmodel->extradata;

	e->frame %= psprite->numframes;

	frame = &psprite->frames[e->frame];
	{	// normal sprite
		up = vup;
		right = vright;
	}

	if ( e->flags & RF_TRANSLUCENT )
		alpha = e->alpha;

	qglColor4f( 1, 1, 1, alpha );
	GL_BindImage( currentmodel->skins[e->frame] );

	GL_TexEnv( GL_MODULATE );
	// For alpha blended sprites.
	qglBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	qglEnable (GL_BLEND);

	qglBegin (GL_QUADS);

	qglTexCoord2f (0, 1);
	VectorMA (e->origin, -frame->origin_y, up, point);
	VectorMA (point, -frame->origin_x, right, point);
	qglVertex3fv (point);

	qglTexCoord2f (0, 0);
	VectorMA (e->origin, frame->height - frame->origin_y, up, point);
	VectorMA (point, -frame->origin_x, right, point);
	qglVertex3fv (point);

	qglTexCoord2f (1, 0);
	VectorMA (e->origin, frame->height - frame->origin_y, up, point);
	VectorMA (point, frame->width - frame->origin_x, right, point);
	qglVertex3fv (point);

	qglTexCoord2f (1, 1);
	VectorMA (e->origin, -frame->origin_y, up, point);
	VectorMA (point, frame->width - frame->origin_x, right, point);
	qglVertex3fv (point);
	
	qglEnd ();

	qglDisable (GL_ALPHA_TEST);
	GL_TexEnv( GL_REPLACE );

#ifdef SIN
   qglDisable( GL_BLEND );
	qglColor4f( 1, 1, 1, alpha );
#else
	if ( alpha != 1.0F )
		qglDisable( GL_BLEND );
#endif
}

#endif

//==================================================================================

/*
=============
R_DrawNullModel
=============
*/
static void R_DrawNullModel (void)
{
	vec3_t	shadelight;
	int		i;

	if ( currententity->flags & RF_FULLBRIGHT )
		shadelight[0] = shadelight[1] = shadelight[2] = 1.0F;
	else
#ifdef SIN
		GL_R_LightPoint (currententity->origin, shadelight, TRUE);
#else
		GL_R_LightPoint (currententity->origin, shadelight);
#endif

    qglPushMatrix ();
	R_RotateForEntity (currententity);

	qglDisable (GL_TEXTURE_2D);
	qglColor3fv (shadelight);

	qglBegin (GL_TRIANGLE_FAN);
	qglVertex3f (0, 0, -16);
	for (i=0 ; i<=4 ; i++)
		qglVertex3f (16*cos(i*M_PI/2), 16*sin(i*M_PI/2), 0);
	qglEnd ();

	qglBegin (GL_TRIANGLE_FAN);
	qglVertex3f (0, 0, 16);
	for (i=4 ; i>=0 ; i--)
		qglVertex3f (16*cos(i*M_PI/2), 16*sin(i*M_PI/2), 0);
	qglEnd ();

	qglColor3f (1,1,1);
	qglPopMatrix ();
	qglEnable (GL_TEXTURE_2D);
}

/*
=============
R_DrawEntitiesOnList
=============
*/
static void R_DrawEntitiesOnList (void)
{
	int		i;
#ifdef SIN
   int      j;
   int      entlist[MAX_ENTITIES];
   int      numents;
   int      farthest = -1;
   entity_t *testent;
#endif

#ifdef SIN
	if (!r_drawentities->value || (r_newrefdef.rdflags & RDF_NOENTITIES))
		return;
#else
	if (!r_drawentities->value)
		return;
#endif

	// draw non-transparent first
	for (i=0 ; i<r_newrefdef.num_entities ; i++)
	{
		currententity = &r_newrefdef.entities[i];

#ifdef SIN
		if (currententity->flags & RF_DONTDRAW)
			continue;
      if ( currententity->flags & RF_LENSFLARE )
         continue;
      if ( currententity->flags & RF_WEAPONMODEL )
         continue;
      if ( currententity->model && currententity->model->type == mod_sprite )
         continue;
      if ( currententity->flags & RF_DETAIL )
         {
         float dist, delta;
         vec3_t diff;

         VectorSubtract( currententity->origin, r_newrefdef.vieworg, diff );

         dist  = DotProduct( diff,diff );
         dist *= r_newrefdef.fovfactor;

         if ( dist > r_detaildist->value )
            {
            delta = Burger::FPMath::Abs(r_detaildist->value - dist);

            if (delta < r_detailthresh->value)
               {
               currententity->alpha *= ( 1.0f - delta / r_detailthresh->value );
               if ( currententity->alpha < 1 )
                  currententity->flags |= RF_TRANSLUCENT;
               }
            else
               continue;
            }
         }
#endif

		if (currententity->flags & RF_TRANSLUCENT)
			continue;	// solid

		if ( currententity->flags & RF_BEAM )
		{
			GL_R_DrawBeam( currententity );
		}
		else
		{
			currentmodel = currententity->model;
			if (!currentmodel)
			{
				R_DrawNullModel ();
				continue;
			}
			switch (currentmodel->type)
			{
			case mod_alias:
				R_DrawAliasModel (currententity);
				break;
			case mod_brush:
				R_DrawBrushModel (currententity);
				break;
			case mod_sprite:
				R_DrawSpriteModel (currententity);
				break;
#ifdef SIN
			case mod_sinmdl:
				SINMDL_DrawModel (currententity);
				break;
#endif
			default:
				ri.Sys_Error (ERR_DROP, "Bad modeltype");
				break;
			}
		}
	}

	// draw transparent entities
	// we could sort these if it ever becomes a problem...
	qglDepthMask (0);		// no z writes
#ifndef SIN
	for (i=0 ; i<r_newrefdef.num_entities ; i++)
	{
		currententity = &r_newrefdef.entities[i];
		if (!(currententity->flags & RF_TRANSLUCENT))
			continue;	// solid

		if ( currententity->flags & RF_BEAM )
		{
			GL_R_DrawBeam( currententity );
		}
		else
		{
			currentmodel = currententity->model;

			if (!currentmodel)
			{
				R_DrawNullModel ();
				continue;
			}
			switch (currentmodel->type)
			{
			case mod_alias:
				R_DrawAliasModel (currententity);
				break;
			case mod_brush:
				R_DrawBrushModel (currententity);
				break;
			case mod_sprite:
				R_DrawSpriteModel (currententity);
				break;
			default:
				ri.Sys_Error (ERR_DROP, "Bad modeltype");
				break;
			}
		}
	}

#else

   numents = 0;
	for (i=0 ; i<r_newrefdef.num_entities ; i++)
	   {
      vec3_t diff;
		currententity = &r_newrefdef.entities[i];
		if (currententity->flags & RF_DONTDRAW)
			continue;
		if (currententity->flags & RF_DONTDRAW)
			continue;
      if ( currententity->flags & RF_DETAIL )
         {
         float dist, delta;
         vec3_t diff;

         VectorSubtract( currententity->origin, r_newrefdef.vieworg, diff );

         dist =  DotProduct( diff,diff );
         dist *= r_newrefdef.fovfactor;

         if ( dist > r_detaildist->value )
            {
            delta = Burger::FPMath::Abs(r_detaildist->value - dist);

            if (delta < r_detailthresh->value)
               {
               currententity->alpha *= ( 1.0f - delta / r_detailthresh->value );
               currententity->flags |= RF_TRANSLUCENT;
               }
            else
               continue;
            }
         }
      if ( currententity->flags & RF_LENSFLARE )
         continue;
      if (
            ( currententity->model) &&
            ( currententity->model->type != mod_sprite ) &&
      		(!(currententity->flags & RF_TRANSLUCENT))
         )
			continue;	// solid

      entlist[numents++] = i;
      VectorSubtract( currententity->origin, r_origin, diff );
      currententity->radius = VectorLength( diff );
      currententity->gravaxis = 0;
      }
   for (i=0;i<numents;i++)
      {
      farthest = -1;
      for (j=0;j<numents;j++)
         {
    		testent = &r_newrefdef.entities[entlist[j]];
         if ( testent->gravaxis < 0 )
            continue;
         if ( farthest < 0 )
            {
            farthest = j;
      		currententity = testent;
            }
         else
            {
            if (testent->radius > currententity->radius)
               {
               farthest = j;
      		   currententity = testent;
               }
            }
         }
		if ( currententity->flags & RF_BEAM )
		   {
			GL_R_DrawBeam( currententity );
		   }
		else
		   {
			currentmodel = currententity->model;

			if (!currentmodel)
			   {
				R_DrawNullModel ();
				continue;
			   }
			switch (currentmodel->type)
			   {
			   case mod_alias:
				   R_DrawAliasModel (currententity);
				   break;
			   case mod_brush:
				   R_DrawBrushModel (currententity);
				   break;
			   case mod_sprite:
				   R_DrawSpriteModel (currententity);
				   break;
			   case mod_sinmdl:
				   SINMDL_DrawModel (currententity);
				   break;
			   default:
				   ri.Sys_Error (ERR_DROP, "Bad modeltype");
				   break;
			   }
   		}
      currententity->gravaxis = -1;
      }
#endif

	qglDepthMask (1);		// back to writing

}



#ifdef SIN
/*
=============
R_DrawLensFlare
=============
*/
static void R_DrawLensFlare (void)
   {
	int		i;

	if (!r_drawentities->value || (r_newrefdef.rdflags & RDF_NOENTITIES))
		return;

	qglDepthFunc (GL_ALWAYS);
   for (i=0 ; i<r_newrefdef.num_entities ; i++)
   	{
		currententity = &r_newrefdef.entities[i];
		if ( currententity->flags & RF_LENSFLARE )
		   {
			currentmodel = currententity->model;
 			if (!currentmodel)
			   {
				R_DrawNullModel ();
				continue;
			   }
         if (currentmodel->type == mod_sprite)
            {
            if ( currententity->skinnum != 255 )
               {
               int lt = currententity->skinnum;
         		if ( lt < 0 )
			         {
			         lt = 0;
			         }
		         else if ( lt >= MAX_LIGHTSTYLES )
			         {
			         lt = 0;
			         }

		         currententity->color_r = r_newrefdef.lightstyles[ lt ].rgb[ 0 ] * 0.5;
		         currententity->color_g = r_newrefdef.lightstyles[ lt ].rgb[ 1 ] * 0.5;
		         currententity->color_b = r_newrefdef.lightstyles[ lt ].rgb[ 2 ] * 0.5;
               }
  				R_DrawSpriteModel (currententity);
            }
         }
      }
	if (gl_ztrick->value)
   	{
		if (ztrickframe & 1)
   		{
			qglDepthFunc (GL_LEQUAL);
   		}
		else
	   	{
			qglDepthFunc (GL_GEQUAL);
		   }
      }
   else
      qglDepthFunc (GL_LEQUAL);
   }


/*
=================
R_DrawWeaponModel
=================
*/
static void R_DrawWeaponModel (void)
   {
	int		i;

	if (!r_drawentities->value || (r_newrefdef.rdflags & RDF_NOENTITIES))
		return;

   for (i=0 ; i<r_newrefdef.num_entities ; i++)
   	{
		currententity = &r_newrefdef.entities[i];
		if ( currententity->flags & RF_WEAPONMODEL )
		   {
			currentmodel = currententity->model;

 			if (!currentmodel)
			   {
				R_DrawNullModel ();
				continue;
			   }

			switch (currentmodel->type)
			   {
			   case mod_alias:
				   R_DrawAliasModel (currententity);
				   break;
			   case mod_brush:
				   R_DrawBrushModel (currententity);
				   break;
			   case mod_sprite:
				   R_DrawSpriteModel (currententity);
				   break;
			   case mod_sinmdl:
				   SINMDL_DrawModel (currententity);
				   break;
			   default:
				   ri.Sys_Error (ERR_DROP, "Bad modeltype");
				   break;
            }
         }
      }
   }

/*
=============
R_DrawDebugLines
=============
*/

static void R_DrawDebugLines(void)
   {
	debugline_t	*line;
	int			i;

	if ( !ri.DebugLines || !ri.numDebugLines )
		{
		return;
		}

	qglDisable (GL_TEXTURE_2D);
	qglEnable (GL_BLEND);

	qglBegin (GL_LINES);

	line = *ri.DebugLines;
	for( i = *ri.numDebugLines; i > 0; i--, line++ )
      {
		qglColor4f( line->color[ 0 ], line->color[ 1 ], line->color[ 2 ], line->alpha );

      qglVertex3fv (line->start);
      qglVertex3fv (line->end);
      }

	qglEnd ();

	qglDisable( GL_BLEND );
	qglEnable (GL_TEXTURE_2D);
   }

#endif

// had to comment out the particle code in assembly, it sucks ass
//#ifndef AMD3D

/*
** GL_DrawParticles
**
*/
void GL_DrawParticles( int num_particles, const particle_t particles[] )
{
	const particle_t *p;
	int            i;
	vec3_t         up, right;
	float       scale;
	vec3_t         tmpup, tmpright;
	
	GL_BindImage( r_particletexture );
	qglDepthMask( GL_FALSE );     // no z buffering
	qglEnable( GL_BLEND );
	GL_TexEnv( GL_MODULATE );
	
	// Do the overbright particles first
	
	qglBlendFunc( GL_ONE, GL_ONE );
	qglBegin( GL_TRIANGLES );
	
	VectorScale (vup, 2.5, up);
	VectorScale (vright, 2.5, right);
	
	for ( p = particles, i=0 ; i < num_particles ; i++,p++) {
		if(!(p->flags & (PARTICLE_OVERBRIGHT|PARTICLE_FIRE|PARTICLE_ADDITIVE)))
			continue;
		
		// don't render flame particles that are closer than 32 units
		if(p->flags & PARTICLE_FIRE) {
			VectorSubtract(p->origin, r_origin, tmpup);
			scale = VectorLength(tmpup);
			if(scale < 40)
				continue;
		}
		
		// hack a scale up to keep particles from disapearing
		scale = ( p->origin[0] - r_origin[0] ) * vpn[0] +
			( p->origin[1] - r_origin[1] ) * vpn[1] +
			( p->origin[2] - r_origin[2] ) * vpn[2];
		
		// added variable sizes
		if(!p->size) { // partizle size 0 indicated a regular particle
			if (scale < 20)
				scale = 1;
			else
				scale = 1 + scale * 0.004;
		
			qglColor4fv( p->color );
		
			qglTexCoord2f( 0.0625, 0.0625 );
			qglVertex3fv( p->origin );
		
			qglTexCoord2f( 1.0625, 0.0625 );
			qglVertex3f( p->origin[0] + up[0]*scale,
				p->origin[1] + up[1]*scale,
				p->origin[2] + up[2]*scale);
		
			qglTexCoord2f( 0.0625, 1.0625 );
			qglVertex3f( p->origin[0] + right[0]*scale,
				p->origin[1] + right[1]*scale,
				p->origin[2] + right[2]*scale);
		
			continue;
		}
		
		// particles using the added effects are handled below
		if(p->size > 1)
			scale /= p->size;
		
		if (scale < 20)
			scale = p->size;
		else
			scale = p->size + scale * 0.004;
		
		qglColor4fv( p->color );
		
		//calc new up and right vectors based on 1/4 the particle's scale
		// this is to reduce the number of multiplies later
		VectorScale(up, (scale*0.25), tmpup);
		VectorScale(right, (scale*0.25), tmpright);
		
		// added flame type particles & changed the particle's
		// vertex positions to center around the origin
		if(p->flags & PARTICLE_FIRE) {
         // randomly flip the particles back and forth a bit
         // to break up their regularity
         if((int)rand()%5)
         {
            qglTexCoord2f(1.03125, 1.03125);
            qglVertex3f( p->origin[0] - tmpup[0] + tmpright[0],
                        p->origin[1] - tmpup[1] + tmpright[1],
                      p->origin[2] - tmpup[2] + tmpright[2]);

            qglTexCoord2f(0.03125, 1.03125);
            qglVertex3f( p->origin[0] - tmpup[0] - tmpright[0]*3,
                        p->origin[1] - tmpup[1] - tmpright[1]*3,
                      p->origin[2] - tmpup[2] - tmpright[2]*3);

            qglTexCoord2f(1.03125, 0.03125);
            qglVertex3f( p->origin[0] + tmpup[0]*3 + tmpright[0],
                        p->origin[1] + tmpup[1]*3 + tmpright[1],
                      p->origin[2] + tmpup[2]*3 + tmpright[2]);
         }
         else
         {
            qglTexCoord2f(1.03125, 1.03125);
            qglVertex3f( p->origin[0] - tmpup[0] - tmpright[0],
                        p->origin[1] - tmpup[1] - tmpright[1],
                      p->origin[2] - tmpup[2] - tmpright[2]);

            qglTexCoord2f(1.03125, 0.03125);
            qglVertex3f( p->origin[0] + tmpup[0]*3 - tmpright[0],
                        p->origin[1] + tmpup[1]*3 - tmpright[1],
                      p->origin[2] + tmpup[2]*3 - tmpright[2]);

            qglTexCoord2f(0.03125, 1.03125);
            qglVertex3f( p->origin[0] - tmpup[0] + tmpright[0]*3,
                        p->origin[1] - tmpup[1] + tmpright[1]*3,
                      p->origin[2] - tmpup[2] + tmpright[2]*3);
         }
      }
      else
      {
         qglTexCoord2f( 0.0625, 0.0625 );
         qglVertex3f( p->origin[0] - tmpup[0] - tmpright[0],
                     p->origin[1] - tmpup[1] - tmpright[1],
                   p->origin[2] - tmpup[2] - tmpright[2]);

         qglTexCoord2f( 1.0625, 0.0625 );
         qglVertex3f( p->origin[0] + tmpup[0]*3 - tmpright[0],
                     p->origin[1] + tmpup[1]*3 - tmpright[1],
                   p->origin[2] + tmpup[2]*3 - tmpright[2]);

         qglTexCoord2f( 0.0625, 1.0625 );
         qglVertex3f( p->origin[0] - tmpup[0] + tmpright[0]*3,
                     p->origin[1] - tmpup[1] + tmpright[1]*3,
                   p->origin[2] - tmpup[2] + tmpright[2]*3);
      }
      }
   qglEnd ();

   // Now do the regular particles

   qglBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
   qglBegin( GL_TRIANGLES );

   VectorScale (vup, 2.5, up);
   VectorScale (vright, 2.5, right);

   for ( p = particles, i=0 ; i < num_particles ; i++,p++)
      {
      // had to add this to not draw fire particles twice
      if(p->flags & (PARTICLE_OVERBRIGHT|PARTICLE_FIRE|PARTICLE_ADDITIVE))
         continue;

      // hack a scale up to keep particles from disapearing
      scale = ( p->origin[0] - r_origin[0] ) * vpn[0] +
             ( p->origin[1] - r_origin[1] ) * vpn[1] +
             ( p->origin[2] - r_origin[2] ) * vpn[2];

      // added variable sizes
      if(!p->size) // partizle size 0 indicated a regular particle
      {
         if (scale < 20)
            scale = 1;
         else
            scale = 1 + scale * 0.004;

         qglColor4fv( p->color );

         qglTexCoord2f( 0.0625, 0.0625 );
         qglVertex3fv( p->origin );

         qglTexCoord2f( 1.0625, 0.0625 );
         qglVertex3f( p->origin[0] + up[0]*scale,
            p->origin[1] + up[1]*scale,
            p->origin[2] + up[2]*scale);

         qglTexCoord2f( 0.0625, 1.0625 );
         qglVertex3f( p->origin[0] + right[0]*scale,
            p->origin[1] + right[1]*scale,
            p->origin[2] + right[2]*scale);


         continue;
      }

      // particles using the added effects are handled below
      if(p->size > 0)
         scale /= p->size;

      if (scale < 20)
         scale = p->size;
      else
         scale = p->size + scale * 0.004;

      qglColor4fv( p->color );

      //calc new up and right vectors based on 1/4 the particle's scale
      // this is to reduce the number of multiplies later
      VectorScale(up, (scale*0.25), tmpup);
      VectorScale(right, (scale*0.25), tmpright);

      // added flame type particles & changed the particle's
      // vertex positions to center around the origin
      qglTexCoord2f( 0.0625, 0.0625 );
      qglVertex3f( p->origin[0] - tmpup[0] - tmpright[0],
                  p->origin[1] - tmpup[1] - tmpright[1],
                p->origin[2] - tmpup[2] - tmpright[2]);

      qglTexCoord2f( 1.0625, 0.0625 );
      qglVertex3f( p->origin[0] + tmpup[0]*3 - tmpright[0],
                  p->origin[1] + tmpup[1]*3 - tmpright[1],
                p->origin[2] + tmpup[2]*3 - tmpright[2]);

      qglTexCoord2f( 0.0625, 1.0625 );
      qglVertex3f( p->origin[0] - tmpup[0] + tmpright[0]*3,
                  p->origin[1] - tmpup[1] + tmpright[1]*3,
                p->origin[2] - tmpup[2] + tmpright[2]*3);
      }
   qglEnd ();

   qglDisable( GL_BLEND );
   qglColor4f( 1,1,1,1 );
   qglDepthMask( 1 );      // back to normal Z buffering
   GL_TexEnv( GL_REPLACE );
   }

/*
===============
GL_R_DrawParticles
===============
*/
static void GL_R_DrawParticles (void)
{
#ifdef SIN
   if ( !r_newrefdef.num_particles )
      return;
#endif

	if ( gl_ext_pointparameters->value && qglPointParameterfEXT && ( !game2015->value ) ) {
		int i;
		const particle_t *p;
	
		qglDepthMask( GL_FALSE );
		qglEnable( GL_BLEND );
		qglDisable( GL_TEXTURE_2D );
	
		qglPointSize( gl_particle_size->value );
	
		qglBegin( GL_POINTS );
		for ( i = 0, p = r_newrefdef.particles; i < r_newrefdef.num_particles; i++, p++ ) {
			qglColor4fv( p->color );
			qglVertex3fv( p->origin );
		}
		qglEnd();
		
		qglDisable( GL_BLEND );
		qglColor4f( 1.0F, 1.0F, 1.0F, 1.0F );
		qglDepthMask( GL_TRUE );
		qglEnable( GL_TEXTURE_2D );
	
	} else {
		GL_DrawParticles( r_newrefdef.num_particles, r_newrefdef.particles );
	}
}

/*
============
R_PolyBlend
============
*/
static void R_PolyBlend (void)
{
	if (!gl_polyblend->value)
		return;
	if (!v_blend[3])
		return;

	qglDisable (GL_ALPHA_TEST);
	qglEnable (GL_BLEND);
	qglDisable (GL_DEPTH_TEST);
	qglDisable (GL_TEXTURE_2D);

    qglLoadIdentity ();

	// FIXME: get rid of these
    qglRotatef (-90,  1, 0, 0);	    // put Z going up
    qglRotatef (90,  0, 0, 1);	    // put Z going up

	qglColor4fv (v_blend);

	qglBegin (GL_QUADS);

	qglVertex3f (10, 100, 100);
	qglVertex3f (10, -100, 100);
	qglVertex3f (10, -100, -100);
	qglVertex3f (10, 100, -100);
	qglEnd ();

	qglDisable (GL_BLEND);
	qglEnable (GL_TEXTURE_2D);
	qglEnable (GL_ALPHA_TEST);

	qglColor4f(1,1,1,1);
}

//=======================================================================

static int SignbitsForPlane (cplane_t *out)
{
	int	bits, j;

	// for fast box on planeside test

	bits = 0;
	for (j=0 ; j<3 ; j++)
	{
		if (out->normal[j] < 0)
			bits |= 1<<j;
	}
	return bits;
}


static void R_SetFrustum (void)
{
	int		i;

#if 0
	/*
	** this code is wrong, since it presume a 90 degree FOV both in the
	** horizontal and vertical plane
	*/
	// front side is visible
	VectorAdd (vpn, vright, frustum[0].normal);
	VectorSubtract (vpn, vright, frustum[1].normal);
	VectorAdd (vpn, vup, frustum[2].normal);
	VectorSubtract (vpn, vup, frustum[3].normal);

	// we theoretically don't need to normalize these vectors, but I do it
	// anyway so that debugging is a little easier
	VectorNormalize( frustum[0].normal );
	VectorNormalize( frustum[1].normal );
	VectorNormalize( frustum[2].normal );
	VectorNormalize( frustum[3].normal );
#else
	// rotate VPN right by FOV_X/2 degrees
	RotatePointAroundVector( frustum[0].normal, vup, vpn, -(90-r_newrefdef.fov_x / 2 ) );
	// rotate VPN left by FOV_X/2 degrees
	RotatePointAroundVector( frustum[1].normal, vup, vpn, 90-r_newrefdef.fov_x / 2 );
	// rotate VPN up by FOV_X/2 degrees
	RotatePointAroundVector( frustum[2].normal, vright, vpn, 90-r_newrefdef.fov_y / 2 );
	// rotate VPN down by FOV_X/2 degrees
	RotatePointAroundVector( frustum[3].normal, vright, vpn, -( 90 - r_newrefdef.fov_y / 2 ) );
#endif

	for (i=0 ; i<4 ; i++)
	{
		frustum[i].type = PLANE_ANYZ;
		frustum[i].dist = DotProduct (r_origin, frustum[i].normal);
		frustum[i].signbits = SignbitsForPlane (&frustum[i]);
	}
}

//=======================================================================

/*
===============
GL_R_SetupFrame
===============
*/
static void GL_R_SetupFrame (void)
{
	int i;
	mleaf_t	*leaf;

	r_framecount++;

// build the transformation matrix for the given view angles
	VectorCopy (r_newrefdef.vieworg, r_origin);

	AngleVectors (r_newrefdef.viewangles, vpn, vright, vup);

// current viewcluster
	if ( !( r_newrefdef.rdflags & RDF_NOWORLDMODEL ) )
	{
		r_oldviewcluster = r_viewcluster;
		r_oldviewcluster2 = r_viewcluster2;
		leaf = GL_Mod_PointInLeaf (r_origin, r_worldmodel);
		r_viewcluster = r_viewcluster2 = leaf->cluster;

		// check above and below so crossing solid water doesn't draw wrong
		if (!leaf->contents)
		{	// look down a bit
			vec3_t	temp;

			VectorCopy (r_origin, temp);
			temp[2] -= 16;
			leaf = GL_Mod_PointInLeaf (temp, r_worldmodel);
         if ( !(leaf->contents & CONTENTS_SOLID) &&
				(leaf->cluster != r_viewcluster2) )
				r_viewcluster2 = leaf->cluster;
		}
		else
		{	// look up a bit
			vec3_t	temp;

			VectorCopy (r_origin, temp);
			temp[2] += 16;
			leaf = GL_Mod_PointInLeaf (temp, r_worldmodel);
         if ( !(leaf->contents & CONTENTS_SOLID) &&
				(leaf->cluster != r_viewcluster2) )
				r_viewcluster2 = leaf->cluster;
		}
	}

	for (i=0 ; i<4 ; i++)
		v_blend[i] = r_newrefdef.blend[i];

	c_brush_polys = 0;
	c_alias_polys = 0;

	// clear out the portion of the screen that the NOWORLDMODEL defines
	if ( r_newrefdef.rdflags & RDF_NOWORLDMODEL )
	{
		qglEnable( GL_SCISSOR_TEST );
		qglClearColor( 0.3, 0.3, 0.3, 1 );
		qglScissor( r_newrefdef.x, gl_vid.height - r_newrefdef.height - r_newrefdef.y, r_newrefdef.width, r_newrefdef.height );
#ifdef SIN
   	if ( r_newrefdef.rdflags & RDF_NOCLEAR )
         {
	      qglClear( GL_DEPTH_BUFFER_BIT );
         }
      else
         {
	      qglClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
         }
#else
	   qglClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
#endif
		qglClearColor( 1, 0, 0.5, 0.5 );
		qglDisable( GL_SCISSOR_TEST );
	}
}


void MYgluPerspective( GLdouble fovy, GLdouble aspect,
		     GLdouble zNear, GLdouble zFar )
{
   GLdouble xmin, xmax, ymin, ymax;

   ymax = zNear * tan( fovy * M_PI / 360.0 );
   ymin = -ymax;

   xmin = ymin * aspect;
   xmax = ymax * aspect;

   xmin += -( 2 * gl_state.camera_separation ) / zNear;
   xmax += -( 2 * gl_state.camera_separation ) / zNear;

   qglFrustum( xmin, xmax, ymin, ymax, zNear, zFar );
}


/*
=============
R_SetupGL
=============
*/
static void R_SetupGL (void)
{
	float	screenaspect;
//	float	yfov;
	int		x, x2, y2, y, w, h;

	//
	// set up viewport
	//
	x = floor(r_newrefdef.x * gl_vid.width / gl_vid.width);
	x2 = ceil((r_newrefdef.x + r_newrefdef.width) * gl_vid.width / gl_vid.width);
	y = floor(gl_vid.height - r_newrefdef.y * gl_vid.height / gl_vid.height);
	y2 = ceil(gl_vid.height - (r_newrefdef.y + r_newrefdef.height) * gl_vid.height / gl_vid.height);

	w = x2 - x;
	h = y - y2;

	qglViewport (x, y2, w, h);

	//
	// set up projection matrix
	//
    screenaspect = (float)r_newrefdef.width/r_newrefdef.height;
//	yfov = 2*atan((float)r_newrefdef.height/r_newrefdef.width)*180/M_PI;
	qglMatrixMode(GL_PROJECTION);
    qglLoadIdentity ();
#ifdef SIN
    MYgluPerspective (r_newrefdef.fov_y,  screenaspect,  4,  7000);
#else
    MYgluPerspective (r_newrefdef.fov_y,  screenaspect,  4,  4096);
#endif

	qglCullFace(GL_FRONT);

	qglMatrixMode(GL_MODELVIEW);
    qglLoadIdentity ();

    qglRotatef (-90,  1, 0, 0);	    // put Z going up
    qglRotatef (90,  0, 0, 1);	    // put Z going up
    qglRotatef (-r_newrefdef.viewangles[2],  1, 0, 0);
    qglRotatef (-r_newrefdef.viewangles[0],  0, 1, 0);
    qglRotatef (-r_newrefdef.viewangles[1],  0, 0, 1);
    qglTranslatef (-r_newrefdef.vieworg[0],  -r_newrefdef.vieworg[1],  -r_newrefdef.vieworg[2]);

//	if ( gl_state.camera_separation != 0 && gl_state.stereo_enabled )
//		qglTranslatef ( gl_state.camera_separation, 0, 0 );

	qglGetFloatv (GL_MODELVIEW_MATRIX, r_world_matrix);

	//
	// set drawing parms
	//
	if (gl_cull->value)
		qglEnable(GL_CULL_FACE);
	else
		qglDisable(GL_CULL_FACE);

	qglDisable(GL_BLEND);
	qglDisable(GL_ALPHA_TEST);
	qglEnable(GL_DEPTH_TEST);
}

/*
=============
R_Clear
=============
*/
#ifdef SIN
int ztrickframe;
#endif

void R_Clear (void)
{
#ifdef SIN
	if (gl_draworder->value)
	{
		if (gl_clear->value)
			qglClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		else
			qglClear (GL_DEPTH_BUFFER_BIT);
		gldepthmin = 1;
		gldepthmax = 0;
		qglDepthFunc (GL_LEQUAL);
	}
	else if (gl_ztrick->value)
#else
	if (gl_ztrick->value)
#endif
	{
		if (gl_clear->value)
			qglClear (GL_COLOR_BUFFER_BIT);

		ztrickframe++;
		if (ztrickframe & 1)
		{
			gldepthmin = 0;
			gldepthmax = 0.49999;
			qglDepthFunc (GL_LEQUAL);
		}
		else
		{
			gldepthmin = 1;
			gldepthmax = 0.5;
			qglDepthFunc (GL_GEQUAL);
		}
	}
	else
	{
		if (gl_clear->value)
			qglClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		else
			qglClear (GL_DEPTH_BUFFER_BIT);
		gldepthmin = 0;
		gldepthmax = 1;
		qglDepthFunc (GL_LEQUAL);
	}

	qglDepthRange (gldepthmin, gldepthmax);

}

static void R_Flash( void )
{
	R_PolyBlend ();
}

/*
================
R_RenderView

r_newrefdef must be set before the first call
================
*/
void R_RenderView (refdef_t *fd)
{
#ifdef SIN
	entity_t	ent;
#endif

	if (r_norefresh->value)
		return;

#ifdef SIN
	// GL_R_PushDlights depends on currententity being set, so create a fake entity
	FastMemSet (&ent, 0, sizeof(ent));
	ent.frame = (int)(r_newrefdef.time*2);
	currententity = &ent;
#endif

	r_newrefdef = *fd;

	if (!r_worldmodel && !( r_newrefdef.rdflags & RDF_NOWORLDMODEL ) )
		ri.Sys_Error (ERR_DROP, "R_RenderView: NULL worldmodel");

#ifdef SIN
   r_newrefdef.fovfactor = r_newrefdef.fov_x / 90.0f;

   if ( gl_showents->value )
      {
		ri.Con_Printf (PRINT_ALL, "time %6.2f ------------------------------------------------------------\n", fd->time );
      }
#endif
	if (r_speeds->value) {
		c_brush_polys = 0;
		c_alias_polys = 0;
	}
	GL_R_PushDlights ();
	
	if (gl_finish->value) {
		qglFinish ();
	}
	GL_R_SetupFrame ();
	R_SetFrustum ();
	R_SetupGL ();
	GL_R_MarkLeaves ();	// done here so we know if we're in water
	R_DrawWorld ();
	R_DrawEntitiesOnList ();
	R_RenderDlights ();
	GL_R_DrawParticles ();
	GL_R_DrawAlphaSurfaces ();
#ifdef SIN
	GL_R_DrawTriangles ();
	R_DrawLensFlare ();
	R_DrawWeaponModel ();
	R_DrawDebugLines();
	GL_DrawPortals();
#endif
	R_Flash();

	if (r_speeds->value)
	{
#ifdef SIN
      static int			fpsindex = 0;
	   static double		fpstimes[16] = {0};
	   static double		fpstotal = 0;
	   static double		fpslasttime = 0;
		double fpstime;

		fpstime   = Sys_Milliseconds() / 1000.0f;
		fpstotal -= fpstimes[ fpsindex ];
		fpstimes[ fpsindex ] = fpstime - fpslasttime;
		fpstotal += fpstimes[ fpsindex ];
		fpsindex  = ( fpsindex + 1 ) & 15;
		fpslasttime = fpstime;

		ri.SCR_CenterPrintf ("%4i wpoly %4i epoly%2i tex%2i lmap %4.1f fps\n",
			c_brush_polys,
			c_alias_polys,
			c_visible_textures,
			c_visible_lightmaps,
         16.0f / fpstotal
         );
#else
		ri.Con_Printf (PRINT_ALL, "%4i wpoly %4i epoly %i tex %i lmaps\n",
			c_brush_polys,
			c_alias_polys,
			c_visible_textures,
			c_visible_lightmaps
         );
#endif
	}
}


static void	R_SetGL2D (void)
   {
	// set 2D virtual screen size
	qglViewport (0,0, gl_vid.width, gl_vid.height);
	qglMatrixMode(GL_PROJECTION);
   qglLoadIdentity ();
#ifdef SIN
  	qglOrtho  (0, gl_vid.width, 0, gl_vid.height, -99999, 99999);
#else
   qglOrtho  (0, gl_vid.width, gl_vid.height, 0, -99999, 99999);
#endif
	qglMatrixMode(GL_MODELVIEW);
   qglLoadIdentity ();
	qglDisable (GL_DEPTH_TEST);
	qglDisable (GL_CULL_FACE);
	qglDisable (GL_BLEND);
	qglEnable (GL_ALPHA_TEST);
	qglColor4f (1,1,1,1);
#ifdef SIN
	GL_consoleInfo.surface_width  = gl_vid.width;
	GL_consoleInfo.surface_height = gl_vid.height;
	GL_consoleInfo.u[0] = 1; GL_consoleInfo.u[1] = 0; GL_consoleInfo.u[2] = 0;
	GL_consoleInfo.v[0] = 0; GL_consoleInfo.v[1] = 1; GL_consoleInfo.v[2] = 0;
	GL_consoleInfo.n[0] = 0; GL_consoleInfo.n[1] = 0; GL_consoleInfo.n[2] = 1;
	GL_consoleInfo.alpha = 1.0f;
#endif
}

static void GL_DrawColoredStereoLinePair( float r, float g, float b, float y )
{
	qglColor3f( r, g, b );
	qglVertex2f( 0, y );
	qglVertex2f( gl_vid.width, y );
	qglColor3f( 0, 0, 0 );
	qglVertex2f( 0, y + 1 );
	qglVertex2f( gl_vid.width, y + 1 );
}

static void GL_DrawStereoPattern( void )
{
#ifdef macintosh
	return;
#else
	int i;

	if ( !( gl_config.renderer & GL_RENDERER_INTERGRAPH ) )
		return;

	if ( !gl_state.stereo_enabled )
		return;

	R_SetGL2D();

	qglDrawBuffer( GL_BACK_LEFT );

	for ( i = 0; i < 20; i++ )
	{
		qglBegin( GL_LINES );
			GL_DrawColoredStereoLinePair( 1, 0, 0, 0 );
			GL_DrawColoredStereoLinePair( 1, 0, 0, 2 );
			GL_DrawColoredStereoLinePair( 1, 0, 0, 4 );
			GL_DrawColoredStereoLinePair( 1, 0, 0, 6 );
			GL_DrawColoredStereoLinePair( 0, 1, 0, 8 );
			GL_DrawColoredStereoLinePair( 1, 1, 0, 10);
			GL_DrawColoredStereoLinePair( 1, 1, 0, 12);
			GL_DrawColoredStereoLinePair( 0, 1, 0, 14);
		qglEnd();

		GLimp_EndFrame();
	}
#endif
}


/*
====================
R_SetLightLevel

====================
*/
static void R_SetLightLevel (void)
{
	vec3_t		shadelight;

	if (r_newrefdef.rdflags & RDF_NOWORLDMODEL)
		return;

	// save off light value for server to look at (BIG HACK!)

#ifdef SIN
	GL_R_LightPoint (r_newrefdef.vieworg, shadelight, TRUE);
#else
	GL_R_LightPoint (r_newrefdef.vieworg, shadelight);
#endif

	// pick the greatest component, which should be the same
	// as the mono value returned by software
	if (shadelight[0] > shadelight[1])
	{
		if (shadelight[0] > shadelight[2])
			r_lightlevel->value = 150*shadelight[0];
		else
			r_lightlevel->value = 150*shadelight[2];
	}
	else
	{
		if (shadelight[1] > shadelight[2])
			r_lightlevel->value = 150*shadelight[1];
		else
			r_lightlevel->value = 150*shadelight[2];
	}

}

/*
@@@@@@@@@@@@@@@@@@@@@
GL_R_RenderFrame

@@@@@@@@@@@@@@@@@@@@@
*/
static void GL_R_RenderFrame (refdef_t *fd)
{
	R_RenderView( fd );
	R_SetLightLevel ();
	R_SetGL2D ();
}


static void R_Register( void )
{
	r_lefthand = ri.Cvar_Get( "hand", "0", CVAR_USERINFO | CVAR_ARCHIVE );
	r_norefresh = ri.Cvar_Get ("r_norefresh", "0", 0);
	r_fullbright = ri.Cvar_Get ("r_fullbright", "0", 0);
	r_drawentities = ri.Cvar_Get ("r_drawentities", "1", 0);
	r_drawworld = ri.Cvar_Get ("r_drawworld", "1", 0);
	r_novis = ri.Cvar_Get ("r_novis", "0", 0);
	r_nocull = ri.Cvar_Get ("r_nocull", "0", 0);
	r_lerpmodels = ri.Cvar_Get ("r_lerpmodels", "1", 0);
	r_speeds = ri.Cvar_Get ("r_speeds", "0", 0);

	r_lightlevel = ri.Cvar_Get ("r_lightlevel", "0", 0);

	gl_nosubimage = ri.Cvar_Get( "gl_nosubimage", "0", 0 );
	gl_allow_software = ri.Cvar_Get( "gl_allow_software", "0", 0 );

   gl_particle_min_size = ri.Cvar_Get( "gl_particle_min_size", "2", CVAR_ARCHIVE );
	gl_particle_max_size = ri.Cvar_Get( "gl_particle_max_size", "40", CVAR_ARCHIVE );
	gl_particle_size = ri.Cvar_Get( "gl_particle_size", "40", CVAR_ARCHIVE );
	gl_particle_att_a = ri.Cvar_Get( "gl_particle_att_a", "0.01", CVAR_ARCHIVE );
	gl_particle_att_b = ri.Cvar_Get( "gl_particle_att_b", "0.0", CVAR_ARCHIVE );
	gl_particle_att_c = ri.Cvar_Get( "gl_particle_att_c", "0.01", CVAR_ARCHIVE );

   gl_modulate = ri.Cvar_Get ("gl_modulate", "1", CVAR_ARCHIVE );
	gl_log = ri.Cvar_Get( "gl_log", "0", 0 );
	gl_bitdepth = ri.Cvar_Get( "gl_bitdepth", "0", 0 );
	gl_mode = ri.Cvar_Get( "gl_mode", "0", CVAR_ARCHIVE );
	gl_lightmap = ri.Cvar_Get ("gl_lightmap", "0", 0);
#ifdef SIN
   gl_shadows = ri.Cvar_Get ("gl_shadows", "0", CVAR_ARCHIVE);
	gl_dynamic = ri.Cvar_Get ("r_dynamic", "1", CVAR_ARCHIVE);
#else
	gl_shadows = ri.Cvar_Get ("gl_shadows", "0", 0);
	gl_dynamic = ri.Cvar_Get ("gl_dynamic", "1", 0);
#endif
	gl_nobind = ri.Cvar_Get ("gl_nobind", "0", 0);
	gl_round_down = ri.Cvar_Get ("gl_round_down", "1", 0);
	gl_picmip = ri.Cvar_Get ("gl_picmip", "0", 0);
	gl_skymip = ri.Cvar_Get ("gl_skymip", "0", 0);
	gl_showtris = ri.Cvar_Get ("gl_showtris", "0", 0);
#ifdef SIN
	gl_ztrick = ri.Cvar_Get ("gl_ztrick", "0", CVAR_ARCHIVE);
#else
	gl_ztrick = ri.Cvar_Get ("gl_ztrick", "0", 0);
#endif
	gl_finish = ri.Cvar_Get ("gl_finish", "0", 0);
	gl_clear = ri.Cvar_Get ("gl_clear", "0", 0);
	gl_cull = ri.Cvar_Get ("gl_cull", "1", 0);
#ifdef SIN
	gl_polyblend = ri.Cvar_Get ("gl_polyblend", "1", CVAR_ARCHIVE);
#else
	gl_polyblend = ri.Cvar_Get ("gl_polyblend", "1", 0);
#endif
	gl_flashblend = ri.Cvar_Get ("gl_flashblend", "0", 0);
	gl_playermip = ri.Cvar_Get ("gl_playermip", "0", 0);
	gl_monolightmap = ri.Cvar_Get( "gl_monolightmap", "0", 0 );
	gl_driver = ri.Cvar_Get( "gl_driver", "opengl32", CVAR_ARCHIVE );
	gl_texturemode = ri.Cvar_Get( "gl_texturemode", "GL_LINEAR_MIPMAP_NEAREST", CVAR_ARCHIVE );
	gl_texturealphamode = ri.Cvar_Get( "gl_texturealphamode", "default", CVAR_ARCHIVE );
	gl_texturesolidmode = ri.Cvar_Get( "gl_texturesolidmode", "default", CVAR_ARCHIVE );
	gl_lockpvs = ri.Cvar_Get( "gl_lockpvs", "0", 0 );
	r_colorbits = ri.Cvar_Get( "r_colorbits", "32", CVAR_ARCHIVE );

	gl_vertex_arrays = ri.Cvar_Get( "gl_vertex_arrays", "0", CVAR_ARCHIVE );
#ifdef SIN
	gl_skintexturemode = ri.Cvar_Get( "gl_skintexturemode", "GL_LINEAR_MIPMAP_NEAREST", CVAR_ARCHIVE );
	gl_drawflat  = ri.Cvar_Get ("r_drawflat", "0", 0);
	gl_draworder = ri.Cvar_Get ("r_draworder", "0", 0);
	r_conchars   = ri.Cvar_Get ("r_conchars", "pics/conchars.tga", 0);
	r_condist    = ri.Cvar_Get ("r_condist", "100000", CVAR_ARCHIVE);
	r_detaildist = ri.Cvar_Get ("r_detaildist", "450000", CVAR_ARCHIVE);
	r_detailthresh = ri.Cvar_Get ("r_detailthresh", "100000", CVAR_ARCHIVE);
	r_conoffset  = ri.Cvar_Get ("r_conoffset", "0.1", CVAR_ARCHIVE);
	r_conthresh  = ri.Cvar_Get ("r_conthresh", "100000", CVAR_ARCHIVE);
	gl_showents  = ri.Cvar_Get ("gl_showents", "0", 0);
	r_monolighting = ri.Cvar_Get ("r_monolighting", "0", 0);
#endif
	gl_ext_swapinterval = ri.Cvar_Get( "gl_ext_swapinterval", "1", CVAR_ARCHIVE );
#ifdef SIN
	gl_ext_palettedtexture = ri.Cvar_Get( "gl_ext_palettedtexture", "2", CVAR_ARCHIVE );
#else
	gl_ext_palettedtexture = ri.Cvar_Get( "gl_ext_palettedtexture", "1", CVAR_ARCHIVE );
#endif
	gl_ext_multitexture = ri.Cvar_Get( "gl_ext_multitexture", "1", CVAR_ARCHIVE );
	gl_ext_pointparameters = ri.Cvar_Get( "gl_ext_pointparameters", "1", CVAR_ARCHIVE );
	gl_ext_compiled_vertex_array = ri.Cvar_Get( "gl_ext_compiled_vertex_array", "1", CVAR_ARCHIVE );

	gl_drawbuffer = ri.Cvar_Get( "gl_drawbuffer", "GL_BACK", 0 );
	gl_swapinterval = ri.Cvar_Get( "gl_swapinterval", "1", CVAR_ARCHIVE );

	gl_saturatelighting = ri.Cvar_Get( "gl_saturatelighting", "0", 0 );

	gl_3dlabs_broken = ri.Cvar_Get( "gl_3dlabs_broken", "1", CVAR_ARCHIVE );

	vid_fullscreen = ri.Cvar_Get( "vid_fullscreen", "1", CVAR_ARCHIVE );
	vid_gamma = ri.Cvar_Get( "vid_gamma", "1.0", CVAR_ARCHIVE );
	vid_ref = ri.Cvar_Get( "vid_ref", "soft", CVAR_ARCHIVE );

#ifdef SIN
	// 2015 code
	game2015 = ri.Cvar_Get ("game2015", "0", 0);

	scr_shotname = ri.Cvar_Get( "scr_shotname", SCREEN_SHOT_NAME, CVAR_ARCHIVE );
	ri.Cmd_AddCommand( "loadportals", GL_LoadPortals );
	gl_showportals = ri.Cvar_Get( "gl_showportals", "0", 0 );
	ri.Cmd_AddCommand( "initfont", GL_Draw_InitLocal );
	ri.Cmd_AddCommand( "loadpal", GL_LoadPalFile_f );
#endif

	ri.Cmd_AddCommand( "imagelist", GL_ImageList_f );
	ri.Cmd_AddCommand( "screenshot", GL_ScreenShot_f );
	ri.Cmd_AddCommand( "modellist", GL_Mod_Modellist_f );
	ri.Cmd_AddCommand( "gl_strings", GL_Strings_f );
}

/*
==================
R_SetMode
==================
*/
static qboolean R_SetMode (void)
{
	rserr_t err;
	qboolean fullscreen;

	if ( vid_fullscreen->modified && !gl_config.allow_cds )
	{
		ri.Con_Printf( PRINT_ALL, "R_SetMode() - CDS not allowed with this driver\n" );
//		ri.Cvar_SetValue( "vid_fullscreen", !vid_fullscreen->value );
		vid_fullscreen->modified = FALSE;
	}

	fullscreen = vid_fullscreen->value;

	vid_fullscreen->modified = FALSE;
	gl_mode->modified = FALSE;

	if ( ( err = (rserr_t)GLimp_SetMode( &gl_vid.width, &gl_vid.height, gl_mode->value, fullscreen ) ) == rserr_ok ) {
		gl_state.prev_mode = gl_mode->value;
	} else {
		if ( err == rserr_invalid_fullscreen )
		{
//			ri.Cvar_SetValue( "vid_fullscreen", 0);
			vid_fullscreen->modified = FALSE;
			ri.Con_Printf( PRINT_ALL, "ref_gl::R_SetMode() - fullscreen unavailable in this mode\n" );
			if ( ( err = (rserr_t)GLimp_SetMode( &gl_vid.width, &gl_vid.height, gl_mode->value, FALSE ) ) == rserr_ok ) {
				return TRUE;
			}
		} else if ( err == rserr_invalid_mode ) {
			ri.Cvar_SetValue( "gl_mode", gl_state.prev_mode );
			gl_mode->modified = FALSE;
			ri.Con_Printf( PRINT_ALL, "ref_gl::R_SetMode() - invalid mode\n" );
		}

		// try setting it back to something safe
		if ( ( err = (rserr_t)GLimp_SetMode( &gl_vid.width, &gl_vid.height, gl_state.prev_mode, FALSE ) ) != rserr_ok ) {
			ri.Con_Printf( PRINT_ALL, "ref_gl::R_SetMode() - could not revert to safe mode\n" );
			return FALSE;
		}
	}
	return TRUE;
}

/*
===============
GL_R_Init
===============
*/
int GL_R_Init( void *hinstance, void *hWnd )
{
	char renderer_buffer[1000];
	char vendor_buffer[1000];
	int      err;
	int		j;
	extern float r_turbsin[256];

	for ( j = 0; j < 256; j++ ) {
		r_turbsin[j] *= 0.5;
	}

	ri.Con_Printf (PRINT_ALL, "ref_gl version: "REF_VERSION"\n");

#ifndef SIN
	Draw_GetPalette ();
#endif

	R_Register();

	if ( !QGL_Init( gl_driver->CVarString ) ) {
		QGL_Shutdown();
		ri.Con_Printf (PRINT_ALL, "ref_gl::GL_R_Init() - could not load \"%s\"\n", gl_driver->CVarString );
		return -1;
	}

	// initialize OS-specific parts of OpenGL
	if ( !GLimp_Init( hinstance, hWnd ) ) {
		QGL_Shutdown();
		return -1;
	}

	// set our "safe" modes
	gl_state.prev_mode = 3;

	// create the window and set up the context
	if ( !R_SetMode () ) {
		QGL_Shutdown();
		ri.Con_Printf (PRINT_ALL, "ref_gl::GL_R_Init() - could not R_SetMode()\n" );
		return -1;
	}

	ri.Vid_MenuInit();

	/*
	** get our various GL strings
	*/
	gl_config.vendor_string = (const char *)qglGetString (GL_VENDOR);
	ri.Con_Printf (PRINT_ALL, "GL_VENDOR: %s\n", gl_config.vendor_string );
	gl_config.renderer_string = (const char *)qglGetString (GL_RENDERER);
	ri.Con_Printf (PRINT_ALL, "GL_RENDERER: %s\n", gl_config.renderer_string );
	gl_config.version_string = (const char *)qglGetString (GL_VERSION);
	ri.Con_Printf (PRINT_ALL, "GL_VERSION: %s\n", gl_config.version_string );
	gl_config.extensions_string = (const char *)qglGetString (GL_EXTENSIONS);
	ri.Con_Printf (PRINT_ALL, "GL_EXTENSIONS: %s\n", gl_config.extensions_string );

	Burger::StringCopy( renderer_buffer, gl_config.renderer_string );
	Burger::StringLowercase( renderer_buffer );

	Burger::StringCopy( vendor_buffer, gl_config.vendor_string );
	Burger::StringLowercase( vendor_buffer );

#if !defined(BURGER_MAC)
   if ( strstr( renderer_buffer, "voodoo" ) )
	{
		if ( !strstr( renderer_buffer, "rush" ) )
			gl_config.renderer = GL_RENDERER_VOODOO;
		else
			gl_config.renderer = GL_RENDERER_VOODOO_RUSH;
	}

   else if ( strstr( vendor_buffer, "sgi" ) )
      gl_config.renderer = GL_RENDERER_SGI;
   else if ( strstr( renderer_buffer, "permedia" ) )
		gl_config.renderer = GL_RENDERER_PERMEDIA2;
	else if ( strstr( renderer_buffer, "glint" ) )
		gl_config.renderer = GL_RENDERER_GLINT_MX;
	else if ( strstr( renderer_buffer, "glzicd" ) )
		gl_config.renderer = GL_RENDERER_REALIZM;
	else if ( strstr( renderer_buffer, "gdi" ) )
		gl_config.renderer = GL_RENDERER_MCD;
	else if ( strstr( renderer_buffer, "pcx2" ) )
		gl_config.renderer = GL_RENDERER_PCX2;
   else if ( strstr( renderer_buffer, "verite" ) )
		gl_config.renderer = GL_RENDERER_RENDITION;
   else
		gl_config.renderer = GL_RENDERER_OTHER;

	if ( toupper( gl_monolightmap->string[1] ) != 'F' ) {
		if ( gl_config.renderer == GL_RENDERER_PERMEDIA2 ) {
			ri.Cvar_Set( "gl_monolightmap", "A" );
			ri.Con_Printf( PRINT_ALL, "...using gl_monolightmap 'a'\n" );
		} else if ( gl_config.renderer & GL_RENDERER_POWERVR ) {
			ri.Cvar_Set( "gl_monolightmap", "0" );
		} else {
			ri.Cvar_Set( "gl_monolightmap", "0" );
		}
	}

	// power vr can't have anything stay in the framebuffer, so
	// the screen needs to redraw the tiled background every frame
	if ( gl_config.renderer & GL_RENDERER_POWERVR ) {
		ri.Cvar_Set( "scr_drawall", "1" );
	} else {
		ri.Cvar_Set( "scr_drawall", "0" );
	}

	// MCD has buffering issues
	if ( gl_config.renderer == GL_RENDERER_MCD ) {
		ri.Cvar_SetValue( "gl_finish", 1 );
	}

	if ( gl_config.renderer & GL_RENDERER_3DLABS ) {
		if ( gl_3dlabs_broken->value )
			gl_config.allow_cds = FALSE;
		else
			gl_config.allow_cds = TRUE;
	} else {
		gl_config.allow_cds = TRUE;
	}

	if ( gl_config.allow_cds ) {
		ri.Con_Printf( PRINT_ALL, "...allowing CDS\n" );
	} else {
		ri.Con_Printf( PRINT_ALL, "...disabling CDS\n" );
	}
#else
	if ( toupper( gl_monolightmap->CVarString[1] ) != 'F' ) {
		ri.Cvar_Set( "gl_monolightmap", "0" );
	}

	ri.Cvar_Set( "scr_drawall", "0" );

	if ( strstr( renderer_buffer, "Voodoo" ) ) {
		if ( strstr( renderer_buffer, "Voodoo 2" ) ) {
			gl_config.renderer = GL_RENDERER_VOODOO2;
		} else if ( strstr( renderer_buffer, "Voodoo 3" ) ) {
			gl_config.renderer = GL_RENDERER_VOODOO3;
		} else {
			gl_config.renderer = GL_RENDERER_VOODOO;
		}
	}

	gl_config.allow_cds = TRUE;
#endif

	/*
	** grab extensions
	*/
#if defined( BURGER_WIN32 ) || defined(BURGER_MAC)
	if (strstr( gl_config.extensions_string, "GL_EXT_compiled_vertex_array" ) ||
		strstr( gl_config.extensions_string, "GL_SGI_compiled_vertex_array" ) ) {
		ri.Con_Printf( PRINT_ALL, "...enabling GL_EXT_compiled_vertex_array\n" );
#if defined(BURGER_MAC)
		qglLockArraysEXT = glLockArraysEXT;
		qglUnlockArraysEXT = glUnlockArraysEXT;
#else
		qglLockArraysEXT = ( void * ) qwglGetProcAddress( "glLockArraysEXT" );
		qglUnlockArraysEXT = ( void * ) qwglGetProcAddress( "glUnlockArraysEXT" );
#endif
	} else {
		ri.Con_Printf( PRINT_ALL, "...GL_EXT_compiled_vertex_array not found\n" );
	}
#ifndef macintosh
	if ( strstr( gl_config.extensions_string, "WGL_EXT_swap_control" ) ) {
		qwglSwapIntervalEXT = ( BOOL (WINAPI *)(int)) qwglGetProcAddress( "wglSwapIntervalEXT" );
		ri.Con_Printf( PRINT_ALL, "...enabling WGL_EXT_swap_control\n" );
	} else {
		ri.Con_Printf( PRINT_ALL, "...WGL_EXT_swap_control not found\n" );
	}
	if ( strstr( gl_config.extensions_string, "GL_EXT_point_parameters" ) ) {
		if ( gl_ext_pointparameters->value ) {
			qglPointParameterfEXT = ( void (APIENTRY *)( GLenum, GLfloat ) ) qwglGetProcAddress( "glPointParameterfEXT" );
			qglPointParameterfvEXT = ( void (APIENTRY *)( GLenum, const GLfloat * ) ) qwglGetProcAddress( "glPointParameterfvEXT" );
			ri.Con_Printf( PRINT_ALL, "...using GL_EXT_point_parameters\n" );
		} else {
			ri.Con_Printf( PRINT_ALL, "...ignoring GL_EXT_point_parameters\n" );
		}
	} else {
		ri.Con_Printf( PRINT_ALL, "...GL_EXT_point_parameters not found\n" );
	}
#ifdef SIN
	if ( strstr( gl_config.extensions_string, "GL_EXT_paletted_texture" ) ) {
		qboolean shared = FALSE;
		if (strstr( gl_config.extensions_string, "GL_EXT_shared_texture_palette" ) )
			shared = TRUE;
		if ( gl_ext_palettedtexture->value ) {
			if (shared)
				ri.Con_Printf( PRINT_ALL, "...using GL_EXT_shared_texture_palette\n" );
			else
				ri.Con_Printf( PRINT_ALL, "...using GL_EXT_texture_palette\n" );
			shared_palette_support = shared;
			qglColorTableEXT = ( void ( APIENTRY * ) ( int, int, int, int, int, const void * ) ) qwglGetProcAddress( "glColorTableEXT" );
		} else {
			ri.Con_Printf( PRINT_ALL, "...ignoring GL_EXT_shared_texture_palette\n" );
		}
	}
#else
	if ( strstr( gl_config.extensions_string, "GL_EXT_paletted_texture" ) &&
		strstr( gl_config.extensions_string, "GL_EXT_shared_texture_palette" ) ) {
		if ( gl_ext_palettedtexture->value ) {
			ri.Con_Printf( PRINT_ALL, "...using GL_EXT_shared_texture_palette\n" );
			qglColorTableEXT = ( void ( APIENTRY * ) ( int, int, int, int, int, const void * ) ) qwglGetProcAddress( "glColorTableEXT" );
		} else {
			ri.Con_Printf( PRINT_ALL, "...ignoring GL_EXT_shared_texture_palette\n" );
		}
	}
#endif
	else {
		ri.Con_Printf( PRINT_ALL, "...GL_EXT_shared_texture_palette not found\n" );
	}

	if ( strstr( gl_config.extensions_string, "GL_SGIS_multitexture" ) ) {
		if ( gl_ext_multitexture->value ) {
			ri.Con_Printf( PRINT_ALL, "...using GL_SGIS_multitexture\n" );
			qglMTexCoord2fSGIS = ( void * ) qwglGetProcAddress( "glMTexCoord2fSGIS" );
			qglSelectTextureSGIS = ( void * ) qwglGetProcAddress( "glSelectTextureSGIS" );
		} else {
			ri.Con_Printf( PRINT_ALL, "...ignoring GL_SGIS_multitexture\n" );
		}
	} else {
		ri.Con_Printf( PRINT_ALL, "...GL_SGIS_multitexture not found\n" );
	}
#else
/*
	if ( strstr( gl_config.extensions_string, "GL_ARB_multitexture" ) )
	{
		if ( gl_ext_multitexture->value )
		{
			ri.Con_Printf( PRINT_ALL, "...using GL_ARB_multitexture\n" );
			qglMTexCoord2fSGIS = ( void * ) glMultiTexCoord2fARB ;
			qglSelectTextureSGIS = ( void * ) glClientActiveTextureARB;
		}
		else
		{
			ri.Con_Printf( PRINT_ALL, "...ignoring GL_ARB_multitexture\n" );
		}
	}
	else
	{
		ri.Con_Printf( PRINT_ALL, "...GL_ARB_multitexture not found\n" );
	}
*/
#endif
#endif

	GL_SetDefaultState();

	/*
	** draw our stereo patterns
	*/
	GL_DrawStereoPattern();

	GL_InitImages ();
	GL_Mod_Init ();
	R_InitParticleTexture ();
	GL_Draw_InitLocal ();

#ifdef SIN
	{
		int i;
		for (i=0;i<256;i++) {
			float rand1=0,rand2=0,rand3=0;
			while ((rand1 == 0.0f) && (rand2 == 0.0f) && (rand3 == 0.0f)) {
				rand1 = (float)rand() / (float)RAND_MAX;
				rand2 = (float)rand() / (float)RAND_MAX;
				rand3 = (float)rand() / (float)RAND_MAX;
			}
			r_solidcolors[i*3+0] = rand1;
			r_solidcolors[i*3+1] = rand2;
			r_solidcolors[i*3+2] = rand3;
			ColorNormalize(&r_solidcolors[i], &r_solidcolors[i]);
		}
	}
#endif
	err = qglGetError();
	if ( err != GL_NO_ERROR ) {
		ri.Con_Printf (PRINT_ALL, "glGetError() = 0x%x\n", err);
	}
	return 0;
}

#ifdef SIN
float ColorNormalize (vec3_t in, vec3_t out)
{
	float	max, scale;

	max = in[0];
	if (in[1] > max)
		max = in[1];
	if (in[2] > max)
		max = in[2];

	if (max == 0)
		return 0;

	scale = 1.0 / max;
	VectorScale (in, scale, out);
	return max;
}
#endif

/*
===============
GL_R_Shutdown
===============
*/
void GL_R_Shutdown (void)
{
	ri.Cmd_RemoveCommand ("modellist");
	ri.Cmd_RemoveCommand ("screenshot");
	ri.Cmd_RemoveCommand ("imagelist");
	ri.Cmd_RemoveCommand ("gl_strings");
#ifdef SIN
	ri.Cmd_RemoveCommand ("initfont");
	ri.Cmd_RemoveCommand ("loadportals");
	ri.Cmd_RemoveCommand( "loadpal" );
#endif
	
	GL_Draw_EndCinematic();			/* Make SURE I have released my movie memory */
	GL_Mod_FreeAll ();
	
	GL_ShutdownImages ();
	Free(gl_state.d_16to8table);
	gl_state.d_16to8table = 0;
	/*
	** shut down OS specific OpenGL stuff like contexts, etc.
	*/
	GLimp_Shutdown();
	
	/*
	** shutdown our QGL subsystem
	*/
	QGL_Shutdown();
}



/*
@@@@@@@@@@@@@@@@@@@@@
GL_R_BeginFrame
@@@@@@@@@@@@@@@@@@@@@
*/
void GL_R_BeginFrame( float camera_separation )
{

	gl_state.camera_separation = camera_separation;

	/*
	** change modes if necessary
	*/
	if ( gl_mode->modified || vid_fullscreen->modified ) {
		// FIXME: only restart of CDS is required
		cvar_t	*ref;

		ref = ri.Cvar_Get ("vid_ref", "gl", 0);
		ref->modified = TRUE;
	}

	if ( gl_log->modified )
	{
		GLimp_EnableLogging( gl_log->value );
		gl_log->modified = FALSE;
	}

	if ( gl_log->value )
	{
		GLimp_LogNewFrame();
	}

	/*
	** update 3Dfx gamma -- it is expected that a user will do a vid_restart
	** after tweaking this value
	*/
	if ( vid_gamma->modified ) {
		vid_gamma->modified = FALSE;
/*
		if ( gl_config.renderer & ( GL_RENDERER_VOODOO ) ) {
			char envbuffer[1024];
			float g;
			g = 2.00 * ( 0.8 - ( vid_gamma->value - 0.5 ) ) + 1.0F;
			Com_sprintf( envbuffer, sizeof(envbuffer), "SST_GAMMA=%f", g );
			putenv( envbuffer );
			Com_sprintf( envbuffer, sizeof(envbuffer), "SSTV2_GAMMA=%f", g );
			putenv( envbuffer );
		}
*/
	}

	GLimp_BeginFrame( camera_separation );

	/*
	** go into 2D mode
	*/
	qglViewport (0,0, gl_vid.width, gl_vid.height);
	qglMatrixMode(GL_PROJECTION);
	qglLoadIdentity();
#ifdef SIN
	qglOrtho(0, gl_vid.width, 0, gl_vid.height, -99999, 99999);
	GL_consoleInfo.surface_width = gl_vid.width;
	GL_consoleInfo.surface_height = gl_vid.height;
	GL_consoleInfo.u[0] = 1; GL_consoleInfo.u[1] = 0; GL_consoleInfo.u[2] = 0;
	GL_consoleInfo.v[0] = 0; GL_consoleInfo.v[1] = 1; GL_consoleInfo.v[2] = 0;
	GL_consoleInfo.n[0] = 0; GL_consoleInfo.n[1] = 0; GL_consoleInfo.n[2] = 1;
	GL_consoleInfo.alpha = 1.0f;
#else
	qglOrtho(0, gl_vid.width, gl_vid.height, 0, -99999, 99999);
#endif
	qglMatrixMode(GL_MODELVIEW);
	qglLoadIdentity ();
	qglDisable (GL_DEPTH_TEST);
	qglDisable (GL_CULL_FACE);
	qglDisable (GL_BLEND);
	qglEnable (GL_ALPHA_TEST);
	qglColor4f (1,1,1,1);

	/*
	** draw buffer stuff
	*/
	if ( gl_drawbuffer->modified ) {
		gl_drawbuffer->modified = FALSE;
		if ( gl_state.camera_separation == 0 || !gl_state.stereo_enabled ) {
			if ( Burger::StringCaseCompare( gl_drawbuffer->CVarString, "GL_FRONT" ) == 0 ) {
				qglDrawBuffer( GL_FRONT );
			} else {
				qglDrawBuffer( GL_BACK );
			}
		}
	}

	/*
	** texturemode stuff
	*/
	if ( gl_texturemode->modified ) {
		GL_TextureMode( gl_texturemode->CVarString );
		gl_texturemode->modified = FALSE;
	}

#ifdef SIN
	if ( gl_skintexturemode->modified ) {
		GL_SkinTextureMode( gl_skintexturemode->CVarString );
		gl_skintexturemode->modified = FALSE;
	}
#endif

	if ( gl_texturealphamode->modified ) {
		GL_TextureAlphaMode( gl_texturealphamode->CVarString );
		gl_texturealphamode->modified = FALSE;
	}

	if ( gl_texturesolidmode->modified ) {
		GL_TextureSolidMode( gl_texturesolidmode->CVarString );
		gl_texturesolidmode->modified = FALSE;
	}
	/*
	** swapinterval stuff
	*/
	GL_UpdateSwapInterval();

	//
	// clear screen if desired
	//
	R_Clear ();
}

/*
=============
R_SetPalette
=============
*/
void R_SetPalette ( const unsigned char *palette)
{
	Word i;
	Word8 *rp;
	Word8 r_rawpalette[1024];
	
	rp = r_rawpalette;

	if (!palette) {
		palette = d_8to24table;
	}
	i = 256;
	do {
		rp[0] = palette[0];
		rp[1] = palette[1];
		rp[2] = palette[2];
		rp[3] = 255;
		palette+=4;
		rp+=4;
	} while (--i);

	GL_SetTexturePalette( r_rawpalette );
	qglClearColor (0,0,0,0);
	qglClear (GL_COLOR_BUFFER_BIT);
	qglClearColor (1,0, 0.5 , 0.5);
}

/*
** GL_R_DrawBeam
*/
void GL_R_DrawBeam( entity_t *e )
{
#define NUM_BEAM_SEGS 6

	int	i;
	float r, g, b;

	vec3_t perpvec;
	vec3_t direction, normalized_direction;
	vec3_t	start_points[NUM_BEAM_SEGS], end_points[NUM_BEAM_SEGS];
	vec3_t oldorigin, origin;

	oldorigin[0] = e->oldorigin[0];
	oldorigin[1] = e->oldorigin[1];
	oldorigin[2] = e->oldorigin[2];

	origin[0] = e->origin[0];
	origin[1] = e->origin[1];
	origin[2] = e->origin[2];

	normalized_direction[0] = direction[0] = oldorigin[0] - origin[0];
	normalized_direction[1] = direction[1] = oldorigin[1] - origin[1];
	normalized_direction[2] = direction[2] = oldorigin[2] - origin[2];

	if ( VectorNormalize( normalized_direction ) == 0 )
		return;

	PerpendicularVector( perpvec, normalized_direction );
#ifdef SIN
	VectorScale( perpvec, (float)e->frame / 2, perpvec );
#else
	VectorScale( perpvec, e->frame / 2, perpvec );
#endif

	for ( i = 0; i < 6; i++ ) {
		RotatePointAroundVector( start_points[i], normalized_direction, perpvec, (360.0/NUM_BEAM_SEGS)*i );
		VectorAdd( start_points[i], origin, start_points[i] );
		VectorAdd( start_points[i], direction, end_points[i] );
	}
	
	qglDisable( GL_TEXTURE_2D );
	qglEnable( GL_BLEND );
	qglDepthMask( GL_FALSE );
	
	qglBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	qglDisable( GL_CULL_FACE );
	if ( e->skinnum == 255 ) {
		r = e->color_r;
		g = e->color_g;
		b = e->color_b;
		qglColor4f( r, g, b, e->alpha );
	} else {
		float a;
	
		i = e->skinnum;
	
		if ( i < 0 ) {
			i = 0;
		} else if ( i >= MAX_LIGHTSTYLES ) {
			i = 0;
		}
	
		r = r_newrefdef.lightstyles[ i ].rgb[ 0 ] * 0.5f;
		g = r_newrefdef.lightstyles[ i ].rgb[ 1 ] * 0.5f;
		b = r_newrefdef.lightstyles[ i ].rgb[ 2 ] * 0.5f;
		a = r_newrefdef.lightstyles[ i ].rgb[ 3 ];
		if ( a < 0 ) {
			a = e->alpha;
		}
		qglColor4f( r, g, b, a );
	}

	qglBegin( GL_TRIANGLE_STRIP );
	for ( i = 0; i < NUM_BEAM_SEGS; i++ ) {
		qglVertex3fv( start_points[i] );
		qglVertex3fv( end_points[i] );
		qglVertex3fv( start_points[(i+1)%NUM_BEAM_SEGS] );
		qglVertex3fv( end_points[(i+1)%NUM_BEAM_SEGS] );
	}
	qglEnd();

#ifdef SIN
	qglEnable( GL_CULL_FACE );
#endif
	qglEnable( GL_TEXTURE_2D );
	qglDisable( GL_BLEND );
	qglDepthMask( GL_TRUE );
}

//===================================================================

/*
@@@@@@@@@@@@@@@@@@@@@
GetRefAPI

@@@@@@@@@@@@@@@@@@@@@
*/

refexport_t GL_GetRefAPI (refimport_t rimp )
{
	refexport_t	re;

	gIsOpenGL = TRUE;

	ri = rimp;

	re.api_version = API_VERSION;

	re.BeginRegistration = GL_R_BeginRegistration;
	re.RegisterModel = GL_R_RegisterModel;
	re.RegisterSkin = GL_R_RegisterSkin;
	re.RegisterPic = GL_Draw_FindPic;
	re.SetSky = GL_R_SetSky;
	re.EndRegistration = GL_R_EndRegistration;

	re.RenderFrame = GL_R_RenderFrame;

	re.DrawGetPicSize = GL_Draw_GetPicSize;
	re.DrawPic = GL_Draw_Pic;
	re.DrawStretchPic = GL_Draw_StretchPic;
	re.DrawChar = GL_Draw_Char;
	re.DrawTileClear = GL_Draw_TileClear;
	re.DrawFill = GL_Draw_Fill;
	re.DrawFadeScreen= GL_Draw_FadeScreen;

	re.Init = (qboolean	(*) ( void *, void * ))GL_R_Init;
	re.Shutdown = GL_R_Shutdown;

	re.CinematicSetPalette = R_SetPalette;
	re.BeginFrame = GL_R_BeginFrame;
	re.EndFrame = GLimp_EndFrame;

	re.AppActivate = GLimp_AppActivate;

#ifdef SIN
	re.DrawChar3D = GL_Draw_Char3D;
	re.DrawPic3D = GL_Draw_Pic3D;
	re.DrawFill3D = GL_Draw_Fill3D;
	re.DrawAltFill3D = Draw_AltFill3D;
	re.DrawStretchPic3D = GL_Draw_StretchPic3D;
	re.DrawTilePic3D = GL_Draw_TilePic3D;
	re.SINMDL_GetDefHandle = GL_SINMDL_GetDefHandle;
	re.TesselateModel = GL_TesselateModel;
	re.BurnLightmap = GL_R_BurnPoint;
	re.GetNumFrames = GL_R_GetNumFrames;
	re.BeginCinematic = GL_Draw_BeginCinematic;
	re.EndCinematic = GL_Draw_EndCinematic;
	re.DrawCinematicFrame = GL_Draw_CinematicFrame;
#ifdef __A3D_GEOM
	re.A3D_RenderGeometry = A3D_RenderGeometry;
#endif
#endif
	Swap_Init ();

	return re;
}


