//-----------------------------------------------------------------------------
//
//  $Logfile:: /win32/sys_win.c                                               $
// $Revision:: 1                                                              $
//   $Author:: Burger                                                         $
//     $Date:: 12/27/00 7:57p                                                 $
//
// Copyright (C) 1998 by Ritual Entertainment, Inc.
// All rights reserved.
//
// This source is may not be distributed and/or modified without
// expressly written permission by Ritual Entertainment, Inc.
//
// $Log:: /win32/sys_win.c                                                    $
 * 
 * 1     12/27/00 7:57p Burger
// 
// 20    3/23/99 5:32p Markd
// Added game host support
// 
// 19    11/12/98 8:47p Markd
// put in check for running from CD gross hack stuff because of Activision's
// stupid launcher KILL KILL KILL
// 
// 18    10/26/98 2:32a Markd
// put in local copy of copy protection support
// 
// 17    10/21/98 6:41p Markd
// fixed scan for cd stuff
// 
// 16    10/20/98 9:16p Markd
// fixed registry stuff and put in deslashify
// 
// 15    10/20/98 2:46a Markd
// Added registry lookup for cddir
// 
// 14    10/18/98 6:41p Markd
// Changed CD Check to NO_CD_CHECK
// 
// 13    10/12/98 12:58p Markd
// preinitialized cd_scan semaphore with false
// 
// 12    10/08/98 8:12p Markd
// put cddir back in
// 
// 11    8/20/98 12:05p Markd
// took out cddir
// 
// 10    8/19/98 6:47p Markd
// Took out scan for cd
// 
// 9     8/02/98 9:01p Markd
// Merged code 3.17
//
// 8     5/24/98 6:34p Jimdose
// Changed char *'s to const char *'s
//
// 7     5/24/98 4:49p Jimdose
// Made char *'s const
//
// 6     1/24/98 5:26p Jimdose
// Eradicated runtime references to Quake
//
// 5     1/22/98 6:41p Jimdose
// Added "gamedll" cvar.  Set gamedll on startup to choose which dll to load.
// This is a temporary solution until player configuration settings are
// created.
//
// 4     12/30/97 6:06p Jimdose
// Added header text
//
// DESCRIPTION:
//

#include "../qcommon/qcommon.h"
#include "winquake.h"
#include "resource.h"
#include <errno.h>
#include <float.h>
#include <fcntl.h>
#include <stdio.h>
#include <direct.h>
#include <io.h>
#include <conio.h>
#include "conproc.h"

#define MINIMUM_WIN_MEMORY	0x0a00000
#define MAXIMUM_WIN_MEMORY	0x1000000

//#define DEMO

qboolean s_win95;

int			starttime;
int			ActiveApp;
qboolean	Minimized;

#ifdef SIN
static cvar_t *gamedll;
static cvar_t *usegh;
#endif

static HANDLE		hinput, houtput;

unsigned	sys_msg_time;
unsigned	sys_frame_time;


static HANDLE		qwclsemaphore;

#define  MAX_NUM_ARGVS  128
int         argc;
char     *argv[MAX_NUM_ARGVS];

#ifdef SIN
void CheckWorkingDirectory( void );
void RestoreWorkingDirectory( void );
#endif

/*
===============================================================================

SYSTEM IO

===============================================================================
*/


#ifdef SIN
void Sys_Error (const char *error, ...)
#else
void Sys_Error (char *error, ...)
#endif
{
	va_list		argptr;
	char		text[1024];

	CL_Shutdown ();
	Qcommon_Shutdown ();

	va_start (argptr, error);
	vsprintf (text, error, argptr);
	va_end (argptr);

	MessageBox(NULL, text, "Error", 0 /* MB_OK */ );

	if (qwclsemaphore)
		CloseHandle (qwclsemaphore);

// shut down QHOST hooks if necessary
   DeinitConProc ();

   exit (1);
}

void Sys_Quit (void)
{
	timeEndPeriod( 1 );

	CL_Shutdown();
	Qcommon_Shutdown ();
	CloseHandle (qwclsemaphore);
	if (dedicated && dedicated->value)
		FreeConsole ();

// shut down QHOST hooks if necessary
   DeinitConProc ();

#ifdef SIN
   RestoreWorkingDirectory();
#endif
   exit (0);
}


void WinError (void)
{
	LPVOID lpMsgBuf;

	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL
	);

	// Display the string.
	MessageBox( NULL, lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

	// Free the buffer.
	LocalFree( lpMsgBuf );
}

/*
================
Sys_ScanForCD

================
*/
#ifdef SIN

char *Sys_ScanForCD (void)
   {
   int i;
   HKEY  hKey;
   long lres, lType, lSize;
   FILE     *f;
   char     test[MAX_QPATH];
   static char cddir[MAX_OSPATH];

   cddir[ 0 ] = 0;

   lres = RegOpenKeyEx( HKEY_LOCAL_MACHINE, "Software\\Ritual Entertainment\\Sin", 0, KEY_READ, &hKey );

   if (lres != ERROR_SUCCESS)
      return cddir;

   lSize = MAX_OSPATH;

   lres = RegQueryValueEx( hKey, "PATH", NULL, &lType, cddir, &lSize );

#if 0
      {
      char temp[1024];

      sprintf( temp, "Contents of PATH = %s", cddir );
	   MessageBox( NULL, temp, "Sys_ScanForCD", MB_OK|MB_ICONINFORMATION );
      }
#endif

   RegCloseKey(hKey);

   if (lres != ERROR_SUCCESS)
      return cddir;

   // no abort/retry/fail errors
   SetErrorMode (SEM_FAILCRITICALERRORS);

   sprintf (test, "%s%s", cddir, ID_CDROM_EXE);

   f = fopen(test, "r");
   if (f)
      {
      char     drive[4];

      drive[0] = cddir[ 0 ];
      drive[1] = ':';
      drive[2] = '\\';
      drive[3] = 0;

      fclose (f);
      if (GetDriveType (drive) == DRIVE_CDROM)
         {
         // 
         // get rid of backslashes
         //
         for( i = 0; i < Burger::StringLength( cddir ); i++ )
            {
            if ( cddir[ i ] == '\\' )
               cddir[ i ] = '/';
            }
         return cddir;
         }
      }

   cddir[ 0 ] = 0;

   return cddir;
   }

#else

char *Sys_ScanForCD (void)
{
   static char cddir[MAX_OSPATH];
   static qboolean   done = false;
#ifndef DEMO
   char     drive[4];
   FILE     *f;
   char     test[MAX_QPATH];

   if (done)      // don't re-check
      return cddir;

   // no abort/retry/fail errors
   SetErrorMode (SEM_FAILCRITICALERRORS);

   drive[0] = 'c';
   drive[1] = ':';
   drive[2] = '\\';
   drive[3] = 0;

   done = true;

   // scan the drives
   for (drive[0] = 'c' ; drive[0] <= 'z' ; drive[0]++)
   {
      // where activision put the stuff...
      sprintf (cddir, "%sinstall\\data", drive);
      sprintf (test, "%sinstall\\data\\quake2.exe", drive);
      f = fopen(test, "r");
      if (f)
      {
         fclose (f);
         if (GetDriveType (drive) == DRIVE_CDROM)
            return cddir;
      }
   }
#endif

   cddir[0] = 0;

   return NULL;
}

#endif

//#define USEPROTECTION
/*
================
Sys_CopyProtect

================
*/
void  Sys_CopyProtect (void)
{
#ifdef USEPROTECTION
   char  *cddir;

   cddir = Sys_ScanForCD();
   if (!cddir[0])
#ifdef SIN
      Com_Error (ERR_FATAL, "You must have the " GAME_NAME " CD in the drive to play.");
#else
      Com_Error (ERR_FATAL, "You must have the Quake2 CD in the drive to play.");
#endif
#endif
}


/*
================
Sys_Init
================
*/
void Sys_Init (void)
{
	OSVERSIONINFO	vinfo;

#if 0
	// allocate a named semaphore on the client so the
	// front end can tell if it is alive

	// mutex will fail if semephore allready exists
    qwclsemaphore = CreateMutex(
        NULL,         /* Security attributes */
        0,            /* owner       */
        "qwcl"); /* Semaphore name      */
	if (!qwclsemaphore)
		Sys_Error ("QWCL is allready running on this system");
	CloseHandle (qwclsemaphore);

    qwclsemaphore = CreateSemaphore(
        NULL,         /* Security attributes */
        0,            /* Initial count       */
        1,            /* Maximum count       */
        "qwcl"); /* Semaphore name      */
#endif

	timeBeginPeriod( 1 );

	vinfo.dwOSVersionInfoSize = sizeof(vinfo);

	if (!GetVersionEx (&vinfo))
		Sys_Error ("Couldn't get OS info");

#ifdef SIN
	if (vinfo.dwMajorVersion < 4)
		Sys_Error ( GAME_NAME " requires windows version 4 or greater");
	if (vinfo.dwPlatformId == VER_PLATFORM_WIN32s)
		Sys_Error ( GAME_NAME "%s doesn't run on Win32s");
   else if ( vinfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
		s_win95 = true;
#else
	if (vinfo.dwMajorVersion < 4)
		Sys_Error ("Quake2 requires windows version 4 or greater");
	if (vinfo.dwPlatformId == VER_PLATFORM_WIN32s)
		Sys_Error ("Quake2 doesn't run on Win32s");
   else if ( vinfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
		s_win95 = true;
#endif

	if (dedicated->value)
	{
		if (!AllocConsole ())
			Sys_Error ("Couldn't create dedicated server console");
		hinput = GetStdHandle (STD_INPUT_HANDLE);
		houtput = GetStdHandle (STD_OUTPUT_HANDLE);

      // let QHOST hook in
      InitConProc (argc, argv);
   }
}


static char console_text[256];
static int  console_textlen;

/*
================
Sys_ConsoleInput
================
*/
#ifdef SIN
const char *Sys_ConsoleInput (void)
#else
char *Sys_ConsoleInput (void)
#endif
{
	INPUT_RECORD	recs[1024];
	int		dummy;
	int		ch, numread, numevents;

	if (!dedicated || !dedicated->value)
		return NULL;


	for ( ;; )
	{
		if (!GetNumberOfConsoleInputEvents (hinput, &numevents))
			Sys_Error ("Error getting # of console events");

		if (numevents <= 0)
			break;

		if (!ReadConsoleInput(hinput, recs, 1, &numread))
			Sys_Error ("Error reading console input");

		if (numread != 1)
			Sys_Error ("Couldn't read console input");

		if (recs[0].EventType == KEY_EVENT)
		{
			if (!recs[0].Event.KeyEvent.bKeyDown)
			{
				ch = recs[0].Event.KeyEvent.uChar.AsciiChar;

				switch (ch)
				{
					case '\r':
						WriteFile(houtput, "\r\n", 2, &dummy, NULL);

                  if (console_textlen)
						{
							console_text[console_textlen] = 0;
							console_textlen = 0;
							return console_text;
						}
						break;

					case '\b':
						if (console_textlen)
						{
							console_textlen--;
							WriteFile(houtput, "\b \b", 3, &dummy, NULL);
						}
						break;

					default:
                  if (ch >= ' ')
						{
							if (console_textlen < sizeof(console_text)-2)
							{
								WriteFile(houtput, &ch, 1, &dummy, NULL);
								console_text[console_textlen] = ch;
								console_textlen++;
							}
						}

						break;

				}
			}
		}
	}

	return NULL;
}


/*
================
Sys_ConsoleOutput

Print text to the dedicated console
================
*/
#ifdef SIN
void Sys_ConsoleOutput (const char *string)
#else
void Sys_ConsoleOutput (char *string)
#endif
{
	int		dummy;
   char  text[256];

	if (!dedicated || !dedicated->value)
		return;

   if (console_textlen)
   {
      text[0] = '\r';
      memset(&text[1], ' ', console_textlen);
      text[console_textlen+1] = '\r';
      text[console_textlen+2] = 0;
      WriteFile(houtput, text, console_textlen+2, &dummy, NULL);
   }

   WriteFile(houtput, string, Burger::StringLength(string), &dummy, NULL);

   if (console_textlen)
      WriteFile(houtput, console_text, console_textlen, &dummy, NULL);
}


/*
================
Sys_SendKeyEvents

Send Key_Event calls
================
*/
void Sys_SendKeyEvents (void)
{
    MSG        msg;

	while (PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE))
	{
		if (!GetMessage (&msg, NULL, 0, 0))
			Sys_Quit ();
		sys_msg_time = msg.time;
      	TranslateMessage (&msg);
      	DispatchMessage (&msg);
	}

	// grab frame time
	sys_frame_time = timeGetTime();
}

/*
================
Sys_GetClipboardData

================
*/
char *Sys_GetClipboardData( void )
{
   char *data = NULL;
   char *cliptext;

   if ( OpenClipboard( NULL ) != 0 )
   {
      HANDLE hClipboardData;

      if ( ( hClipboardData = GetClipboardData( CF_TEXT ) ) != 0 )
      {
         if ( ( cliptext = GlobalLock( hClipboardData ) ) != 0 )
         {
            data = malloc( GlobalSize( hClipboardData ) + 1 );
            Burger::StringCopy( data, cliptext );
            GlobalUnlock( hClipboardData );
         }
      }
      CloseClipboard();
   }
   return data;
}


/*
==============================================================================

 WINDOWS CRAP

==============================================================================
*/

/*
=================
Sys_AppActivate
=================
*/
void Sys_AppActivate (void)
{
	ShowWindow ( cl_hwnd, SW_RESTORE);
	SetForegroundWindow ( cl_hwnd );
}

/*
========================================================================

GAME DLL

========================================================================
*/

static HINSTANCE	game_library;

/*
=================
Sys_UnloadGame
=================
*/
void Sys_UnloadGame (void)
{
	if (!FreeLibrary (game_library))
		Com_Error (ERR_FATAL, "FreeLibrary failed for game library");
	game_library = NULL;
}

/*
=================
Sys_GetGameAPI

Loads the game dll
=================
*/
void *Sys_GetGameAPI (void *parms)
{
	void	*(*GetGameAPI) (void *);
	char	name[MAX_OSPATH];
#ifdef SIN
	const char	*path;
#else
	char	*path;
#endif
	char	cwd[MAX_OSPATH];
#if defined _M_IX86
   const char *gamename = "gamex86.dll";

#ifdef NDEBUG
   const char *debugdir = "release";
#else
   const char *debugdir = "debug";
#endif

#elif defined _M_ALPHA
	const char *gamename = "gameaxp.dll";

#ifdef NDEBUG
   const char *debugdir = "releaseaxp";
#else
   const char *debugdir = "debugaxp";
#endif

#endif

	if (game_library)
		Com_Error (ERR_FATAL, "Sys_GetGameAPI without Sys_UnloadingGame");

	Com_DPrintf ("LoadLibrary()\n");

#ifdef SIN
	gamedll = Cvar_Get( "gamedll", "", 0 );
	if ( gamedll->string[0] )
		{
		game_library = LoadLibrary ( gamedll->string );
		if (game_library)
			{
			Com_DPrintf ("LoadLibrary (%s)\n", gamedll->string );
			}
		else
			{
			Com_DPrintf ("Couldn't load %s\n", gamedll->string );
			return NULL;
			}
		}
	else
		{
#endif

      // check the current directory for other development purposes
      Com_sprintf (name, sizeof(name), "%s/%s", cwd, gamename);
      game_library = LoadLibrary ( name );
      if (game_library)
      {
         Com_DPrintf ("LoadLibrary (%s)\n", name);
      }
      else
		{
			// now run through the search paths
			path = NULL;
			while (1)
			{
				path = FS_NextPath (path);
				if (!path)
					return NULL;		// couldn't find one anywhere
				Com_sprintf (name, sizeof(name), "%s/%s", path, gamename);
				game_library = LoadLibrary (name);
				if (game_library)
				{
					Com_DPrintf ("LoadLibrary (%s)\n",name);
					break;
				}
			}
		}
#ifdef SIN
		}
#endif


	GetGameAPI = (void *)GetProcAddress (game_library, "GetGameAPI");
	if (!GetGameAPI)
	{
		Sys_UnloadGame ();
		return NULL;
	}

	return GetGameAPI (parms);
}

//=======================================================================


/*
==================
ParseCommandLine

==================
*/
void ParseCommandLine (LPSTR lpCmdLine)
{
	argc = 1;
	argv[0] = "exe";

	while (*lpCmdLine && (argc < MAX_NUM_ARGVS))
	{
		while (*lpCmdLine && ((*lpCmdLine <= 32) || (*lpCmdLine > 126)))
			lpCmdLine++;

		if (*lpCmdLine)
		{
			argv[argc] = lpCmdLine;
			argc++;

			while (*lpCmdLine && ((*lpCmdLine > 32) && (*lpCmdLine <= 126)))
				lpCmdLine++;

			if (*lpCmdLine)
			{
				*lpCmdLine = 0;
				lpCmdLine++;
			}

		}
	}

}

/*
==================
WinMain

==================
*/
HINSTANCE	global_hInstance;

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
   MSG	msg;
	int	time, oldtime, newtime;
   char  *cddir;

    /* previous instances do not exist in Win32 */
    if (hPrevInstance)
        return 0;

	global_hInstance = hInstance;

	ParseCommandLine (lpCmdLine);

#ifdef SIN
   CheckWorkingDirectory();
#endif

   // if we find the CD, add a +set cddir xxx command line
   cddir = Sys_ScanForCD ();
   if (cddir && argc < MAX_NUM_ARGVS - 3)
   {
      int      i;

      // don't override a cddir on the command line
      for (i=0 ; i<argc ; i++)
         if (!strcmp(argv[i], "cddir"))
            break;
      if (i == argc)
      {
         argv[argc++] = "+set";
         argv[argc++] = "cddir";
         argv[argc++] = cddir;
      }
   }

   Qcommon_Init (argc, argv);

   // check for game host support
	usegh = Cvar_Get( "usegh", "0", 0 );
   if ( usegh->value )
      {
      LoadLibrary ( "ghostinj.dll" );
      }

	oldtime = Sys_Milliseconds ();

    /* main window message loop */
	while (1)
	{
		// if at a full screen console, don't update unless needed
		if (Minimized || (dedicated && dedicated->value) )
		{
			Sleep (1);
		}

		while (PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if (!GetMessage (&msg, NULL, 0, 0))
				Com_Quit ();
			sys_msg_time = msg.time;
			TranslateMessage (&msg);
   			DispatchMessage (&msg);
		}

      do
		{
			newtime = Sys_Milliseconds ();
         time = newtime - oldtime;
		} while (time < 1);
//			Con_Printf ("time:%5.2f - %5.2f = %5.2f\n", newtime, oldtime, time);
      _controlfp( _PC_24, _MCW_PC );
      Qcommon_Frame (time);
		oldtime = newtime;
	}

	// never gets here
    return TRUE;
}

#ifdef SIN
static char  saved_cwd[ MAX_OSPATH ];
static qboolean directory_changed = false;

/*
==================
CheckWorkingDirectory
==================
*/
void CheckWorkingDirectory( void )
{
   char  destdir[ MAX_OSPATH ];
   char  windowsdir[ MAX_OSPATH ];
   char  sinfile[ MAX_OSPATH ];
   int   currentdrive;
   char  drive[4];
   qboolean failed;

   currentdrive = _getdrive();

   drive[0] = 'A' + currentdrive - 1;
   drive[1] = ':';
   drive[2] = '\\';
   drive[3] = 0;

   if (GetDriveType (drive) != DRIVE_CDROM)
      return;

   //
   // looks like we ran from the CD uh-oh!
   //

   failed = false;

   if ( !failed && !GetWindowsDirectory( windowsdir, MAX_OSPATH ) )
      {
      failed = true;
      }

	Com_sprintf( sinfile, sizeof( sinfile ), "%s\\sin_setup.ini", windowsdir );

   if ( !failed && !GetPrivateProfileString( "Global - String1", "Data", "", destdir, MAX_OSPATH, sinfile ) )
      {
      failed = true;
      }

   //
   // if we failed for any reason, go with a default directory and drive
   //
   if ( failed )
      {
      Burger::StringCopy( destdir, "c:\\Program Files\\sin" );
      FS_CreatePath( destdir );
      }

	_getcwd( saved_cwd, MAX_OSPATH );
   directory_changed = true;

   //
   // change the directory on that drive
   //
   _chdir( destdir );

   //
   // change to that drive
   //
   currentdrive = toupper( destdir[ 0 ] ) - 'A' + 1;
   _chdrive( currentdrive );
   }

/*
==================
RestoreWorkingDirectory
==================
*/
void RestoreWorkingDirectory( void )
{
   int   currentdrive;

   if ( !directory_changed )
      return;

   directory_changed = false;

   //
   // change the directory on that drive
   //
   _chdir( saved_cwd );

   //
   // change to that drive
   //
   currentdrive = toupper( saved_cwd[ 0 ] ) - 'A' + 1;
   _chdrive( currentdrive );
   }

#endif